! ver.1.2.00 (2022.2.25)

program main

! ifort VA-FDTD_SOLVER_2D.f90 /O3 /Qopenmp /assume:byterecl
! pgfortran -o VA-FDTD_SOLVER_2D.exe -fast -fasesse -mp VA-FDTD_SOLVER_2D.f90
! gfortran -o VA-FDTD_SOLVER_2D.exe -O3 -fopenmp -ffree-line-length-none VA-FDTD_SOLVER_2D.f90

! OpenMPp
	!$use omp_lib

! Öٌ^錾gp֎~
	implicit none

! ϐ錾

	! ޗ}bv
	integer*2,	dimension(:,:),			allocatable		:: mi

	! PML}bv
	integer*2,	dimension(:,:),			allocatable		:: pi
	integer*2,	dimension(:,:,:),		allocatable		:: pl

	! E}bv
	integer*2,	dimension(:,:,:),		allocatable		:: bc
	integer*2,	dimension(:,:,:),		allocatable		:: msd
	integer*2,	dimension(:,:,:),		allocatable		:: ag

	! qx
	real*8,		dimension(:,:,:),		allocatable		:: vx
	real*8,		dimension(:,:,:),		allocatable		:: vy
	real*8,		dimension(:,:),			allocatable		:: vx2
	real*8,		dimension(:,:),			allocatable		:: vy2

	! _~[ψʁA_~[qx
	real*8,		dimension(:,:,:,:),		allocatable		:: xx
	real*8,		dimension(:,:,:,:),		allocatable		:: xxp
	real*8,		dimension(:,:,:,:),		allocatable		:: xxpp

	! 
	real*8,		dimension(:,:,:),		allocatable		:: txx
	real*8,		dimension(:,:,:),		allocatable		:: tyy

	! f
	real*8,		dimension(:,:,:),		allocatable		:: txy

	! PMLCs[_Xpp[^i͍XVpj
	real*8,		dimension(:,:,:),		allocatable		:: ept

	! C萔pp[^iqxXVpj
	real*8,		dimension(:,:,:,:),		allocatable		:: epv

	! ψ
	real*8,		dimension(:,:,:),		allocatable		:: u
	real*8,		dimension(:,:,:),		allocatable		:: uc

	! OԃXebv̗qx
	real*8,		dimension(:,:,:),		allocatable		:: rrp

	! OԃXebv̗qx
	real*8,		dimension(:,:,:),		allocatable		:: vp

	! 
	real*8,		dimension(:,:),			allocatable		:: navu

	! ͔g`
	real*8,		dimension(:),			allocatable		:: tin
	real*8,		dimension(:),			allocatable		:: tinsum

	! ԃXebv
	real*8,		dimension(:,:,:),		allocatable		:: de

	! E萔
	real*8,		dimension(:,:),			allocatable		:: mck

	! ő̗̔
	real*8,		dimension(:,:,:),		allocatable		:: oj
	real*8,		dimension(:,:,:),		allocatable		:: dpm

	! WW
	real*8,		dimension(:),			allocatable		:: zx, zy

	! ő̕Rt
	integer*4,	dimension(:,:),			allocatable		:: sidx, sid, fidx, fid, fpidx

	! oݒ萔
	real*8,		dimension(:),			allocatable		:: drpts, drpti, drptj, dsrfv
	integer*4,	dimension(:),			allocatable		:: rpts, rpti, rptj, srfv

	! x
	real*8			:: rho(0:256)

	! W
	real*8			:: ca(0:256,2)
	real*8			:: cb(0:256)
	real*8			:: cc(0:256)

	! SW
	real*8			:: xa(0:256,2)
	real*8			:: xb(0:256)
	real*8			:: xc(0:256)

	! C萔
	real*8			:: eta(0:256,2)

	! PML萔
	real*8			:: rl(256,2)
	real*8			:: tr(256,2)
	real*8			:: ld(256,2)

	! ԃXLbv
	integer*4		:: timeskip(0:256)

	! `͈
	real*8			:: minX, maxX, minY, maxY
	real*8			:: pmlMinX, pmlMaxX, pmlMinY, pmlMaxY

	! őgEő厞
	real*8			:: fmax, tmax

	! Ǎpꎞ萔
	real*8			:: dix, djx, dtx, ddistex, dsosel, didr, djdr, dtdr, ddframe, ddpframe, doutputSelect, ddim
	real*8			:: dmatCount, dpmlCount, dptCount, drptCount, dsrfCount, dsurfCount
	real*8			:: dtimeskip, ratio

	! Ǎp萔
	integer*4		:: matCount, pmlCount, ptCount, rptCount, srfCount, surfCount
	character*256	:: rptstr, srfstr

	! Ɨ̈
	integer*4		:: irange
	integer*4		:: t, i, j, l, tx, ix, jx, idr, jdr, tdr, tmul
	integer*4		:: distex, sosel, dframe, dpframe, outputSelect, n, s, m, ii, iii, ompn
	integer*4		:: i1, i2, j1, j2
	real*8			:: dt, a1, a2, rw, mxy, xic
	real*8			:: d(2), et(2), rr(2), a(3,3), exy(2)
	real*8			:: mu(0:1,0:1), ka(0:1,0:1), mt(0:1,0:1), ext(0:1,0:1,2), del(0:1,2)
	real*8			:: txxt(0:1), tyyt(0:1), txyt(0:1), v(0:1,2), vpp(0:1,2)
	real*8			:: tmpx, tmpy
	real*8			:: ee1, ee2, gg1, gg2, m1p, m1m, m3p, m3m, nn1, nn3, aa1, aa3, bb1, bb3, ff1, ff3, hh1, hh2, ii9, jj9, kk1, kk3, ll1, ll3
	real*8			:: sigma, Zresist, Zreact
	real*8			:: tintmp
	character*256	:: fn, fno, str

	! Ԍv
	integer*4			:: tcount
	real*8				:: txstep
	real*8, parameter	:: tpact = 1.0d0
	character*10		:: date, time, zone
	integer				:: values(8)

    ! ParaViewp
	integer*4			:: scellcount, fcellcount, spointcount, fpointcount
	integer*4			:: tmpscellcount, tmpfcellcount, tmpspointcount, tmpfpointcount
	character			:: buffer*256, lf*1, number1*8, number2*8

! f[^Ǎ

	call getarg(1, fn)
	!$ call getarg(2, fno)
	!$ read(fno,*) ompn
	!$ call omp_set_dynamic(.false.)
	!$ call omp_set_num_threads(ompn)
	!$ call omp_set_nested(.true.)

	! it@CI[v
	open(3, file='output/'//trim(fn)//'.out', status='replace')

	! io
	write(*,'(a)') 'FDTD_SOLVER_2D'
	write(3,'(a)') 'FDTD_SOLVER_2D'
	call date_and_time(date, time, zone, values)
	write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Process           start     : ', &
		values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
	write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Process           start     : ', &
		values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

	! t@CI[vi擾pj
	open(1, file='input/'//trim(fn)//'.fdc', access='direct', status='old', recl=8)

	! 
	read(1,rec=1) ddim
	if(ddim .eq. 3.0d0) stop

	! 
	read(1,rec=2) dix
	read(1,rec=3) djx
	read(1,rec=4) dtx

		ix	= nint(dix)
		jx	= nint(djx)
		tx	= nint(dtx)

	! t@CN[Yi擾pj
	close(1)

	! xuiMPIƂ̑Ή̂߁j
	irange	= ix

	! Im
	allocate(mi(0:irange+1,0:jx+1))
	allocate(pi(0:irange+1,0:jx+1))
	allocate(pl(0:irange+1,0:jx+1,2))
	allocate(bc(0:irange+1,0:jx+1,2))
	allocate(msd(0:irange+1,0:jx+1,2))
	allocate(ag(0:irange+1,0:jx+1,2))
	allocate(vx(0:irange+1,0:jx+1,2))
	allocate(vy(0:irange+1,0:jx+1,2))
	allocate(vx2(0:irange+1,0:jx+1))
	allocate(vy2(0:irange+1,0:jx+1))
	allocate(xx(0:irange+1,0:jx+1,3,2))
	allocate(xxp(0:irange+1,0:jx+1,3,2))
	allocate(xxpp(0:irange+1,0:jx+1,3,2))
	allocate(txx(0:irange+1,0:jx+1,2))
	allocate(tyy(0:irange+1,0:jx+1,2))
	allocate(txy(0:irange+1,0:jx+1,2))
	allocate(ept(0:irange+1,0:jx+1,2))
	allocate(epv(0:irange+1,0:jx+1,2,2))
	allocate(rrp(0:irange+1,0:jx+1,2))
	allocate(vp(0:irange+1,0:jx+1,2))
	allocate(navu(0:irange+1,0:jx+1))
	allocate(tin(tx))
	allocate(tinsum(tx))
	allocate(de(0:irange+1,0:jx+1,2))

	! t@CI[v
	open(1, file='input/'//trim(fn)//'.fdc', access='direct', status='old', recl=8)

	! `͈͏
	read(1,rec=5) minX
	read(1,rec=6) maxX
	read(1,rec=7) minY
	read(1,rec=8) maxY
	read(1,rec=9) pmlMinX
	read(1,rec=10) pmlMaxX
	read(1,rec=11) pmlMinY
	read(1,rec=12) pmlMaxY

	! őgEő厞
	read(1,rec=13) fmax
	read(1,rec=14) tmax

	! EUîÊj
	read(1,rec=15) ddistex
	read(1,rec=16) dsosel
	read(1,rec=17) didr
	read(1,rec=18) djdr
	read(1,rec=19) dtdr

		distex	= nint(ddistex)
		sosel	= nint(dsosel)
		idr		= nint(didr)
		jdr		= nint(djdr)
		tdr		= nint(dtdr)

	tintmp	= 0.0d0
	do i = 1, tx
		if(i .le. tdr) then
			read(1,rec=19+i) tin(i)
			tintmp		= tintmp + tin(i)
			tinsum(i)	= tintmp
		else
			tin(i)		= 0.0d0
			tinsum(i)	= tintmp
		end if
	end do

	! 󉹓_EU_
	read(1,rec=tdr+20) drptCount

		rptCount	= nint(drptCount)
		if(rptCount .ge. 1) then
			allocate(drpts(0:rptCount-1))
			allocate(drpti(0:rptCount-1))
			allocate(drptj(0:rptCount-1))
			allocate(rpts(0:rptCount-1))
			allocate(rpti(0:rptCount-1))
			allocate(rptj(0:rptCount-1))
		end if

	if(rptCount .ge. 1) then
		do i = 1, rptCount

			read(1,rec=tdr+20+(i-1)*3+1) drpts(i-1)
			read(1,rec=tdr+20+(i-1)*3+2) drpti(i-1)
			read(1,rec=tdr+20+(i-1)*3+3) drptj(i-1)

				rpts(i-1)	= nint(drpts(i-1))
				rpti(i-1)	= nint(drpti(i-1))
				rptj(i-1)	= nint(drptj(i-1))

		end do
	end if
	
	read(1,rec=tdr+21+rptCount*3) dsrfCount

		srfCount	= nint(dsrfCount)
		if(srfCount .ge. 1) then
			allocate(dsrfv(0:srfCount-1))
			allocate(srfv(0:srfCount-1))
		end if

	if(srfCount .ge. 1) then
		do i = 1, srfCount

			read(1,rec=tdr+21+rptCount*3+i) dsrfv(i-1)

				srfv(i-1)	= nint(dsrfv(i-1))

		end do
	end if

	! o͏
	read(1,rec=tdr+22+rptCount*3+srfCount) doutputSelect
	read(1,rec=tdr+23+rptCount*3+srfCount) ddframe
	read(1,rec=tdr+24+rptCount*3+srfCount) ddpframe
	read(1,rec=tdr+25+rptCount*3+srfCount) ratio

		outputSelect	= nint(doutputSelect)
		dframe			= nint(ddframe)
		dpframe			= nint(ddpframe)

	! Im
	if((outputSelect .eq. 0) .or. (outputSelect .eq. 1)) then
		allocate(uc(0:irange+1,0:jx+1,2))
	end if
	if((outputSelect .eq. 0) .or. (outputSelect .eq. 2)) then
		allocate(u(0:irange+1,0:jx+1,2))	! qxɒ`
		allocate(oj(0:irange+1,0:jx+1,2))	! qxɒ`
		allocate(dpm(0:irange+1,0:jx+1,2))	! ߓ_ɒ`
		allocate(zx(0:irange+1))			! Obhɒ`
		allocate(zy(0:jx+1))				! Obhɒ`
	end if

	! ޗ
	read(1,rec=tdr+26+rptCount*3+srfCount) dmatCount

		matCount	= nint(dmatCount)

		! ` mi(i,j) = 0
		rho(0)		= 0.0d0
		ca(0,1)		= 0.0d0
		ca(0,2)		= 0.0d0
		cb(0)		= 0.0d0
		cc(0)		= 1.0d0
		xa(0,1)		= 0.0d0
		xa(0,2)		= 0.0d0
		xb(0)		= 0.0d0
		xc(0)		= 1.0d0
		eta(0,1)	= 0.0d0
		eta(0,2)	= 0.0d0
		timeskip(0)	= 1000000

	if(matCount .ge. 1) then
		do i = 1, matCount
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+1) rho(i)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+2) ca(i,1)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+3) ca(i,2)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+4) cb(i)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+5) cc(i)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+6) xa(i,1)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+7) xa(i,2)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+8) xb(i)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+9) xc(i)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+10) eta(i,1)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+11) eta(i,2)
			read(1,rec=tdr+26+rptCount*3+srfCount+(i-1)*12+12) dtimeskip
			timeskip(i)	= nint(dtimeskip)
		end do
	end if

	! PML
	read(1,rec=tdr+27+rptCount*3+srfCount+matCount*12) dpmlCount

		pmlCount	= nint(dpmlCount)

		! PMLȂ
		rl(1,1)		= 0.0d0
		rl(1,2)		= 0.0d0
	 	tr(1,1)		= 0.0d0
		tr(1,2)		= 0.0d0
	 	ld(1,1)		= 1.0d0
		ld(1,2)		= 1.0d0

	if(pmlCount .ge. 1) then
		do i = 1, pmlCount
			read(1,rec=tdr+27+rptCount*3+srfCount+matCount*12+(i-1)*6+1) rl(i+1,1)
			read(1,rec=tdr+27+rptCount*3+srfCount+matCount*12+(i-1)*6+2) rl(i+1,2)
			read(1,rec=tdr+27+rptCount*3+srfCount+matCount*12+(i-1)*6+3) tr(i+1,1)
			read(1,rec=tdr+27+rptCount*3+srfCount+matCount*12+(i-1)*6+4) tr(i+1,2)
			read(1,rec=tdr+27+rptCount*3+srfCount+matCount*12+(i-1)*6+5) ld(i+1,1)
			read(1,rec=tdr+27+rptCount*3+srfCount+matCount*12+(i-1)*6+6) ld(i+1,2)
		end do
	end if

	! E
	read(1,rec=tdr+28+rptCount*3+srfCount+matCount*12+pmlCount*6) dsurfCount

		surfCount	= nint(dsurfCount)
		allocate(mck(surfCount,7))

	if(surfCount .ge. 1) then
		do i = 1, surfCount
			read(1,rec=tdr+28+rptCount*3+srfCount+matCount*12+pmlCount*6+(i-1)*7+1) mck(i,1)
			read(1,rec=tdr+28+rptCount*3+srfCount+matCount*12+pmlCount*6+(i-1)*7+2) mck(i,2)
			read(1,rec=tdr+28+rptCount*3+srfCount+matCount*12+pmlCount*6+(i-1)*7+3) mck(i,3)
			read(1,rec=tdr+28+rptCount*3+srfCount+matCount*12+pmlCount*6+(i-1)*7+4) mck(i,4)
			read(1,rec=tdr+28+rptCount*3+srfCount+matCount*12+pmlCount*6+(i-1)*7+5) mck(i,5)
			read(1,rec=tdr+28+rptCount*3+srfCount+matCount*12+pmlCount*6+(i-1)*7+6) mck(i,6)
			read(1,rec=tdr+28+rptCount*3+srfCount+matCount*12+pmlCount*6+(i-1)*7+7) mck(i,7)
		end do
	end if

	! iq_萔
	read(1,rec=tdr+29+rptCount*3+srfCount+matCount*12+pmlCount*6+surfCount*7) dptCount

		ptCount		= nint(dptCount)

	! ԃXebv
	read(1,rec=tdr+30+rptCount*3+srfCount+matCount*12+pmlCount*6+surfCount*7) dt

	! ԃXebv
	do i = 0, ix + 1
	do j = 0, jx + 1
		read(1,rec=tdr+30+rptCount*3+srfCount+matCount*12+pmlCount*6+surfCount*7+i*(jx+2)*2+j*2+1) de(i,j,1)
		read(1,rec=tdr+30+rptCount*3+srfCount+matCount*12+pmlCount*6+surfCount*7+i*(jx+2)*2+j*2+2) de(i,j,2)
	end do
	end do

	! t@CN[Y
	close(1)

	! t@CI[v
	open(1, file='input/'//trim(fn)//'.fds', access='direct', status='old', recl=2)

	! e_ǂݍ
	do ii = 1 , (irange + 1) * (jx + 1)
		i	= int((ii - 1) / (jx + 1))
		j	= mod(ii - 1, (jx + 1))
		read(1,rec=(ii-1)*10+1)		mi(i,j)
		read(1,rec=(ii-1)*10+2)		pi(i,j)
		read(1,rec=(ii-1)*10+3)		pl(i,j,1)
		read(1,rec=(ii-1)*10+4)		pl(i,j,2)
		read(1,rec=(ii-1)*10+5)		bc(i,j,1)
		read(1,rec=(ii-1)*10+6)		bc(i,j,2)
		read(1,rec=(ii-1)*10+7)		msd(i,j,1)
		read(1,rec=(ii-1)*10+8)		msd(i,j,2)
		read(1,rec=(ii-1)*10+9)		ag(i,j,1)
		read(1,rec=(ii-1)*10+10)	ag(i,j,2)
	end do

	! t@CN[Y
	close(1)

! ol}Xψʏ
	!$omp parallel do private(i,j,m,n)
	do i = 0, irange + 1
	do j = 0, jx + 1
	do m = 1, 3
	do n = 1, 2
		xx(i,j,m,n)	= 0.0d0
		xxp(i,j,m,n)	= 0.0d0
		xxpp(i,j,m,n)	= 0.0d0
	end do
	end do
	end do
	end do

! OE_~[
	i = 0
	!$omp parallel do private(j,m)
	do j = 0, jx + 1
	do m = 1, 2
		bc(i,j,m)	= 0
	end do
	end do

	i = irange + 1
	!$omp parallel do private(j,m)
	do j = 0, jx + 1
	do m = 1, 2
		bc(i,j,m)	= 0
	end do
	end do

	j = 0
	!$omp parallel do private(i,m)
	do i = 0, irange + 1
	do m = 1, 2
		bc(i,j,m)	= 0
	end do
	end do

	j = jx + 1
	!$omp parallel do private(i,m)
	do i = 0, irange + 1
	do m = 1, 2
		bc(i,j,m)	= 0
	end do
	end do

! ޗ}bv_~[
	i = 0
	!$omp parallel do private(j,m)
	do j = 0, jx + 1
		mi(i,j) = 0
		pi(i,j) = 1
		do m = 1, 2
			pl(i,j,m) = 1
		end do
	end do

	i = irange + 1
	!$omp parallel do private(j,m)
	do j = 0, jx + 1
		mi(i,j) = 0
		pi(i,j) = 1
		do m = 1, 2
			pl(i,j,m) = 1
		end do
	end do

	j = 0
	!$omp parallel do private(i,m)
	do i = 0, irange + 1
		mi(i,j) = 0
		pi(i,j) = 1
		do m = 1, 2
			pl(i,j,m) = 1
		end do
	end do

	j = jx + 1
	!$omp parallel do private(i,m)
	do i = 1, irange + 1
		mi(i,j) = 0
		pi(i,j) = 1
		do m = 1, 2
			pl(i,j,m) = 1
		end do
	end do

	if((outputSelect .eq. 0) .or. (outputSelect .eq. 1)) then

		! EUg`o
		open(1, file='output/matlab/point/'//trim(fn)//'_source', access='direct', status='replace', recl=8)
			do t = 1, tdr
				write(1,rec=t) tin(t)
			end do
		close(1)

		! ݒt@Co

		open(1, file='output/matlab/point/'//trim(fn)//'.ini', access='direct', status='replace', recl=8)
		open(2, file='output/matlab/surf/'//trim(fn)//'.ini', access='direct', status='replace', recl=8)

			write(1,rec=1) dt			! ԃXebv
			write(1,rec=2) dix			! xőCfbNXl
			write(1,rec=3) djx			! yőCfbNXl
			write(1,rec=4) 2.0d0		! zőCfbNXl
			write(1,rec=5) dtx			! ԍőCfbNXl
			write(1,rec=6) ddframe		! t[
			write(1,rec=7) minX			! xŏliPML)
			write(1,rec=8) maxX			! xőliPML)
			write(1,rec=9) minY			! yŏliPML)
			write(1,rec=10) maxY		! yőliPML)
			write(1,rec=11) 0.0d0		! zŏliPML)
			write(1,rec=12) 0.0d0		! zőliPML)
			write(1,rec=13) pmlMinX		! xŏl
			write(1,rec=14) pmlMaxX		! xől
			write(1,rec=15) pmlMinY		! yŏl
			write(1,rec=16) pmlMaxY		! yől
			write(1,rec=17) 0.0d0		! zŏl
			write(1,rec=18) 0.0d0		! zől
			write(1,rec=19) drptCount
			do i = 1, rptCount
				write(1,rec=19+i) drpts(i-1)
			end do
			do i = 1, rptCount
				write(1,rec=19+rptCount+i) dble(timeskip(mi(rpti(i-1),rptj(i-1))))
			end do
			write(1,rec=20+rptCount*2) dsrfCount
			do i = 1, srfCount
				write(1,rec=20+rptCount*2+i) 2.0d0
			end do
			do i = 1, ix
				write(1,rec=20+rptCount*2+srfCount+i) de(i,1,1)
			end do
			do j = 1, jx
				write(1,rec=20+rptCount*2+srfCount+ix+j) de(1,j,2)
			end do
			write(1,rec=21+rptCount*2+srfCount+ix+jx) 1.0d0
			write(1,rec=22+rptCount*2+srfCount+ix+jx) 1.0d0
			
			write(2,rec=1) dt			! ԃXebv
			write(2,rec=2) dix			! xőCfbNXl
			write(2,rec=3) djx			! yőCfbNXl
			write(2,rec=4) 2.0d0		! zőCfbNXl
			write(2,rec=5) dtx			! ԍőCfbNXl
			write(2,rec=6) ddframe		! t[
			write(2,rec=7) minX			! xŏliPML)
			write(2,rec=8) maxX			! xőliPML)
			write(2,rec=9) minY			! yŏliPML)
			write(2,rec=10) maxY		! yőliPML)
			write(2,rec=11) 0.0d0		! zŏliPML)
			write(2,rec=12) 0.0d0		! zőliPML)
			write(2,rec=13) pmlMinX		! xŏl
			write(2,rec=14) pmlMaxX		! xől
			write(2,rec=15) pmlMinY		! yŏl
			write(2,rec=16) pmlMaxY		! yől
			write(2,rec=17) 0.0d0		! zŏl
			write(2,rec=18) 0.0d0		! zől
			write(2,rec=19) drptCount
			do i = 1, rptCount
				write(2,rec=19+i) drpts(i-1)
			end do
			do i = 1, rptCount
				write(2,rec=19+rptCount+i) dble(timeskip(mi(rpti(i-1),rptj(i-1))))
			end do
			write(2,rec=20+rptCount*2) dsrfCount
			do i = 1, srfCount
				write(2,rec=20+rptCount*2+i) 2.0d0
			end do
			do i = 1, ix
				write(2,rec=20+rptCount*2+srfCount+i) de(i,1,1)
			end do
			do j = 1, jx
				write(2,rec=20+rptCount*2+srfCount+ix+j) de(1,j,2)
			end do
			write(2,rec=21+rptCount*2+srfCount+ix+jx) 1.0d0
			write(2,rec=22+rptCount*2+srfCount+ix+jx) 1.0d0

		close(1)
		close(2)

		! e_f[^o
		do i = 0, rptCount - 1
			if(rptCount .le. 10) then
				write(rptstr,'(i1)') i
			elseif(rptCount .le. 100) then
				write(rptstr,'(i2.2)') i
			elseif(rptCount .le. 1000) then
				write(rptstr,'(i3.3)') i
			elseif(rptCount .le. 10000) then
				write(rptstr,'(i4.4)') i
			elseif(rptCount .le. 100000) then
				write(rptstr,'(i5.5)') i
			end if
			open(11+i, file='output/matlab/point/'//trim(fn)//'_rpt'//trim(rptstr), access='direct', status='replace', recl=8)
		end do

	end if

	if((outputSelect .eq. 0) .or. (outputSelect .eq. 2)) then

		! ő̗̔}bv
		!$omp parallel do private(i,j)
		do i = 0, irange + 1
		do j = 0, jx + 1
			do m = 1, 2
				oj(i,j,m) = 0.0d0
			end do
		end do
		end do

		! ParaViewpv
		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Preprocess for ParaView out : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Preprocess for ParaView out : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! WW
		zx(0)	= pmlMinX
		do i = 1, irange
			zx(i)	= zx(i-1) + de(i,1,1)
		end do
		zy(0)	= pmlMinY
		do j = 1, jx
			zy(j)	= zy(j-1) + de(1,j,2)
		end do

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid cell  count  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid cell  count  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ő̃Z
		scellcount	= 0
		do i = 1, irange
		do j = 1, jx
			if((cc(mi(i,j)) .ne. 0.0d0) .and. (mi(i,j) .ne. 0) .and. (pi(i,j) .eq. 1)) then
				scellcount	= scellcount + 1
			end if
		end do
		end do

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid point count  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid point count  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ő̃|Cg
		spointcount	= 0
		do i = 0, irange
		do j = 0, jx
			if((i .eq. 0) .and. (j .eq. 0)) then
				if((cc(mi(i+1,j+1))   .ne. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) then
					spointcount	= spointcount + 1
				end if
			elseif((i .eq. irange) .and. (j .eq. jx)) then
				if((cc(mi(i,j))       .ne. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) then
					spointcount	= spointcount + 1
				end if
			elseif(j .eq. 0) then
				if( ((cc(mi(i,j+1))   .ne. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .ne. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					spointcount	= spointcount + 1
				end if
			elseif(i .eq. 0) then
				if( ((cc(mi(i+1,j))   .ne. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .ne. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					spointcount	= spointcount + 1
				end if
			elseif(j .eq. jx) then
				if( ((cc(mi(i,j))     .ne. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.& 
					((cc(mi(i+1,j))   .ne. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) ) then
					spointcount	= spointcount + 1
				end if
			elseif(i .eq. irange) then
				if( ((cc(mi(i,j))     .ne. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.& 
					((cc(mi(i,j+1))   .ne. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) ) then
					spointcount	= spointcount + 1
				end if
			else
				if( ((cc(mi(i,j))     .ne. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.&
					((cc(mi(i+1,j))   .ne. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) .or.&
					((cc(mi(i,j+1))   .ne. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .ne. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					spointcount	= spointcount + 1
				end if
			end if
		end do
		end do

		! m
		allocate(sidx(spointcount,2))
		allocate(sid(scellcount,4))

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid point index  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid point index  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ő̃|CgCfbNX
		tmpspointcount	= 0
		do i = 0, irange
		do j = 0, jx
			if((i .eq. 0) .and. (j .eq. 0)) then
				if((cc(mi(i+1,j+1))   .ne. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) then
					tmpspointcount	= tmpspointcount + 1
					sidx(tmpspointcount,1)	= i
					sidx(tmpspointcount,2)	= j
				end if
			elseif((i .eq. irange) .and. (j .eq. jx)) then
				if((cc(mi(i,j))       .ne. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) then
					tmpspointcount	= tmpspointcount + 1
					sidx(tmpspointcount,1)	= i
					sidx(tmpspointcount,2)	= j
				end if
			elseif(j .eq. 0) then
				if( ((cc(mi(i,j+1))   .ne. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .ne. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					tmpspointcount	= tmpspointcount + 1
					sidx(tmpspointcount,1)	= i
					sidx(tmpspointcount,2)	= j
				end if
			elseif(i .eq. 0) then
				if( ((cc(mi(i+1,j))   .ne. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .ne. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					tmpspointcount	= tmpspointcount + 1
					sidx(tmpspointcount,1)	= i
					sidx(tmpspointcount,2)	= j
				end if
			elseif(j .eq. jx) then
				if( ((cc(mi(i,j))     .ne. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.& 
					((cc(mi(i+1,j))   .ne. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) ) then
					tmpspointcount	= tmpspointcount + 1
					sidx(tmpspointcount,1)	= i
					sidx(tmpspointcount,2)	= j
				end if
			elseif(i .eq. irange) then
				if( ((cc(mi(i,j))     .ne. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.& 
					((cc(mi(i,j+1))   .ne. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) ) then
					tmpspointcount	= tmpspointcount + 1
					sidx(tmpspointcount,1)	= i
					sidx(tmpspointcount,2)	= j
				end if
			else
				if( ((cc(mi(i,j))     .ne. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.&
					((cc(mi(i+1,j))   .ne. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) .or.&
					((cc(mi(i,j+1))   .ne. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .ne. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					tmpspointcount	= tmpspointcount + 1
					sidx(tmpspointcount,1)	= i
					sidx(tmpspointcount,2)	= j
				end if
			end if
		end do
		end do

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid point assoc. : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid point assoc. : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ő̃|CgRt
		tmpscellcount	= 0
		do i = 1, irange
		do j = 1, jx
			if((cc(mi(i,j)) .ne. 0.0d0) .and. (mi(i,j) .ne. 0) .and. (pi(i,j) .eq. 1)) then
				tmpscellcount	= tmpscellcount + 1
				do l = 1, spointcount
					if((sidx(l,1) .eq. i - 1) .and. (sidx(l,2) .eq. j - 1)) then
						sid(tmpscellcount,1)	= l - 1
						exit
					end if
				end do
				do l = 1, spointcount
					if((sidx(l,1) .eq. i    ) .and. (sidx(l,2) .eq. j - 1)) then
						sid(tmpscellcount,2)	= l - 1
						exit
					end if
				end do
				do l = 1, spointcount
					if((sidx(l,1) .eq. i    ) .and. (sidx(l,2) .eq. j    )) then
						sid(tmpscellcount,3)	= l - 1
						exit
					end if
				end do
				do l = 1, spointcount
					if((sidx(l,1) .eq. i - 1) .and. (sidx(l,2) .eq. j    )) then
						sid(tmpscellcount,4)	= l - 1
						exit
					end if
				end do
			end if
		end do
		end do

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid cell  count  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid cell  count  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ̃Z
		fcellcount	= 0
		do i = 1, irange
		do j = 1, jx
			if((cc(mi(i,j)) .eq. 0.0d0) .and. (mi(i,j) .ne. 0) .and. (pi(i,j) .eq. 1)) then
				fcellcount	= fcellcount + 1
			end if
		end do
		end do

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid point count  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid point count  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ̃|Cg
		fpointcount	= 0
		do i = 0, irange
		do j = 0, jx
			if((i .eq. 0) .and. (j .eq. 0)) then
				if((cc(mi(i+1,j+1))   .eq. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) then
					fpointcount	= fpointcount + 1
				end if
			elseif((i .eq. irange) .and. (j .eq. jx)) then
				if((cc(mi(i,j))       .eq. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) then
					fpointcount	= fpointcount + 1
				end if
			elseif(j .eq. 0) then
				if( ((cc(mi(i,j+1))   .eq. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .eq. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					fpointcount	= fpointcount + 1
				end if
			elseif(i .eq. 0) then
				if( ((cc(mi(i+1,j))   .eq. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .eq. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					fpointcount	= fpointcount + 1
				end if
			elseif(j .eq. jx) then
				if( ((cc(mi(i,j))     .eq. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.& 
					((cc(mi(i+1,j))   .eq. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) ) then
					fpointcount	= fpointcount + 1
				end if
			elseif(i .eq. irange) then
				if( ((cc(mi(i,j))     .eq. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.& 
					((cc(mi(i,j+1))   .eq. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) ) then
					fpointcount	= fpointcount + 1
				end if
			else
				if( ((cc(mi(i,j))     .eq. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.&
					((cc(mi(i+1,j))   .eq. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) .or.&
					((cc(mi(i,j+1))   .eq. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .eq. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					fpointcount	= fpointcount + 1
				end if
			end if
		end do
		end do

		! m
		allocate(fidx(fpointcount,2))
		allocate(fid(fcellcount,4))
		allocate(fpidx(fcellcount,2))

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid point index  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid point index  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ̃|CgCfbNX
		tmpfpointcount	= 0
		do i = 0, irange
		do j = 0, jx
			if((i .eq. 0) .and. (j .eq. 0)) then
				if((cc(mi(i+1,j+1))   .eq. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) then
					tmpfpointcount	= tmpfpointcount + 1
					fidx(tmpfpointcount,1)	= i
					fidx(tmpfpointcount,2)	= j
				end if
			elseif((i .eq. irange) .and. (j .eq. jx)) then
				if((cc(mi(i,j))       .eq. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) then
					tmpfpointcount	= tmpfpointcount + 1
					fidx(tmpfpointcount,1)	= i
					fidx(tmpfpointcount,2)	= j
				end if
			elseif(j .eq. 0) then
				if( ((cc(mi(i,j+1))   .eq. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .eq. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					tmpfpointcount	= tmpfpointcount + 1
					fidx(tmpfpointcount,1)	= i
					fidx(tmpfpointcount,2)	= j
				end if
			elseif(i .eq. 0) then
				if( ((cc(mi(i+1,j))   .eq. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) .or.&
					((cc(mi(i+1,j+1)) .eq. 0.0d0) .and. (mi(i+1,j+1) .ne. 0) .and. (pi(i+1,j+1) .eq. 1)) ) then
					tmpfpointcount	= tmpfpointcount + 1
					fidx(tmpfpointcount,1)	= i
					fidx(tmpfpointcount,2)	= j
				end if
			elseif(j .eq. jx) then
				if( ((cc(mi(i,j))     .eq. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.& 
					((cc(mi(i+1,j))   .eq. 0.0d0) .and. (mi(i+1,j)   .ne. 0) .and. (pi(i+1,j)   .eq. 1)) ) then
					tmpfpointcount	= tmpfpointcount + 1
					fidx(tmpfpointcount,1)	= i
					fidx(tmpfpointcount,2)	= j
				end if
			elseif(i .eq. irange) then
				if( ((cc(mi(i,j))     .eq. 0.0d0) .and. (mi(i,j)     .ne. 0) .and. (pi(i,j)     .eq. 1)) .or.& 
					((cc(mi(i,j+1))   .eq. 0.0d0) .and. (mi(i,j+1)   .ne. 0) .and. (pi(i,j+1)   .eq. 1)) ) then
					tmpfpointcount	= tmpfpointcount + 1
					fidx(tmpfpointcount,1)	= i
					fidx(tmpfpointcount,2)	= j
				end if
			else
				if( ((cc(mi(i,j))       .eq. 0.0d0) .and. (mi(i,j)       .ne. 0) .and. (pi(i,j)       .eq. 1)) .or.&
					((cc(mi(i+1,j))     .eq. 0.0d0) .and. (mi(i+1,j)     .ne. 0) .and. (pi(i+1,j)     .eq. 1)) .or.&
					((cc(mi(i,j+1))     .eq. 0.0d0) .and. (mi(i,j+1)     .ne. 0) .and. (pi(i,j+1)     .eq. 1)) .or.&
					((cc(mi(i+1,j+1))   .eq. 0.0d0) .and. (mi(i+1,j+1)   .ne. 0) .and. (pi(i+1,j+1)   .eq. 1)) ) then
					tmpfpointcount	= tmpfpointcount + 1
					fidx(tmpfpointcount,1)	= i
					fidx(tmpfpointcount,2)	= j
				end if
			end if
		end do
		end do

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid point assoc. : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid point assoc. : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ̃|CgRt
		tmpfcellcount	= 0
		do i = 1, irange
		do j = 1, jx
			if((cc(mi(i,j)) .eq. 0.0d0) .and. (mi(i,j) .ne. 0) .and. (pi(i,j) .eq. 1)) then
				tmpfcellcount	= tmpfcellcount + 1
				do l = 1, fpointcount
					if((fidx(l,1) .eq. i - 1) .and. (fidx(l,2) .eq. j - 1)) then
						fid(tmpfcellcount,1)	= l - 1
						exit
					end if
				end do
				do l = 1, fpointcount
					if((fidx(l,1) .eq. i    ) .and. (fidx(l,2) .eq. j - 1)) then
						fid(tmpfcellcount,2)	= l - 1
						exit
					end if
				end do
				do l = 1, fpointcount
					if((fidx(l,1) .eq. i    ) .and. (fidx(l,2) .eq. j    )) then
						fid(tmpfcellcount,3)	= l - 1
						exit
					end if
				end do
				do l = 1, fpointcount
					if((fidx(l,1) .eq. i - 1) .and. (fidx(l,2) .eq. j    )) then
						fid(tmpfcellcount,4)	= l - 1
						exit
					end if
				end do
			end if
		end do
		end do

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid cell  index  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-fluid cell  index  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ̃ZCfbNX
		tmpfcellcount	= 0
		do i = 1, irange
		do j = 1, jx
			if((cc(mi(i,j)) .eq. 0.0d0) .and. (mi(i,j) .ne. 0) .and. (pi(i,j) .eq. 1)) then
				tmpfcellcount	= tmpfcellcount + 1
				fpidx(tmpfcellcount,1)	= i
				fpidx(tmpfcellcount,2)	= j
			end if
		end do
		end do

		call date_and_time(date, time, zone, values)
		write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid/fluid judge  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'ParaView-solid/fluid judge  : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

		! ő̗̔
		do i = 0, irange
		do j = 1, jx
			if(i .eq. 0) then
				if(cc(mi(i+1,j)) .ne. 0.0d0) then
					oj(i,j,1)	= 1.0d0
				end if
			elseif(i .eq. irange) then
				if(cc(mi(i,j)) .ne. 0.0d0) then
					oj(i,j,1)	= 1.0d0
				end if
			else
				if((cc(mi(i,j)) .ne. 0.0d0) .or. (cc(mi(i+1,j)) .ne. 0.0d0)) then
					oj(i,j,1)	= 1.0d0
				end if
			end if
		end do
		end do

		do i = 1, irange
		do j = 0, jx
			if(j .eq. 0) then
				if(cc(mi(i,j+1)) .ne. 0.0d0) then
					oj(i,j,2)	= 1.0d0
				end if
			elseif(j .eq. irange) then
				if(cc(mi(i,j)) .ne. 0.0d0) then
					oj(i,j,2)	= 1.0d0
				end if
			else
				if((cc(mi(i,j)) .ne. 0.0d0) .or. (cc(mi(i,j+1)) .ne. 0.0d0)) then
					oj(i,j,2)	= 1.0d0
				end if
			end if
		end do
		end do

	end if

! PMLW
	!$omp parallel do private(i,j,m,n)
	do i = 0, irange + 1
	do j = 0, jx + 1
		if(mi(i,j) .eq. 0) then
			! (i,j)ɍޗݒȂȂept̓_~[li0.0d0ȊOȂȂł悢jAepv0.0d0
			do m = 1, 2
				ept(i,j,m)	= 1.0d0
				do n = 1, 2
					epv(i,j,n,m)	= 0.0d0
				end do
			end do
		else
			if(pi(i,j) .eq. 1) then
				! (i,j)PMLłȂꍇ
				do m = 1, 2
					ept(i,j,m)	= 0.0d0
					do n = 1, 2
						epv(i,j,m,n)	= dt * timeskip(mi(i,j)) / 2.0d0 / rho(mi(i,j)) * eta(mi(i,j),m)
					end do
				end do
			else
				! (i,j)PML̏ꍇ
				do m = 1, 2
					if(rl(pi(i,j),m) .eq. 0.0d0) then
						! młȂꍇ
						ept(i,j,m)	= 0.0d0
						do n = 1, 2
							epv(i,j,n,m)	= dt * timeskip(mi(i,j)) / 2.0d0 / rho(mi(i,j)) * eta(mi(i,j),n)
						end do
					else
						! m̏ꍇ
						ept(i,j,m)	= rl(pi(i,j),m) * (dble(pl(i,j,m)) / ld(pi(i,j),m)) ** tr(pi(i,j),m)
						do n = 1, 2
							epv(i,j,n,m)	= ept(i,j,m)
						end do
					end if
				end do
			end if
		end if
	end do
	end do

! io
	tcount	= 1
	txstep	= dble(tx) * tpact / 100.0d0
	call date_and_time(date, time, zone, values)
	write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Preprocess        completed : ', &
		values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
	write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Preprocess        completed : ', &
		values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
	call date_and_time(date, time, zone, values)
	write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Calculation       start     : ', &
		values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
	write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Calculation       start     : ', &
		values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

! ԃ[v
do t = 1, tx

	! qxXV
	! xqx
	!$omp parallel do private(i,j,tmul,n,et,txxt,txyt,rw,d,a1,a2,i1,i2,ee1,ee2,gg1,gg2,m1p,m1m,m3p,m3m,nn1,nn3,aa1,aa3,bb1,bb3,ff1,ff3,hh1,hh2,ii9,jj9,kk1,kk3,ll1,ll3,sigma,Zresist,Zreact)
	do i = 0, irange
	do j = 1, jx

		i1	= i
		i2	= i + 1
		if((bc(i,j,1) .eq. 5) .or. (bc(i,j,1) .eq. 15)) then
			i2	= 1
		end if
		if((bc(i+1,j,1) .eq. -5) .or. (bc(i+1,j,1) .eq. 15)) then
			i1	= irange
		end if

		if(mi(i1,j) + mi(i2,j) .ne. 0) then
		tmul	= min(timeskip(mi(i1,j)), timeskip(mi(i2,j)))
		if(mod(t, tmul) .eq. 0) then
			
			do n = 1, 2
				et(n)	= (epv(i1,j,1,n) * de(i1,j,1) + epv(i2,j,1,n) * de(i2,j,1)) / (de(i1,j,1) + de(i2,j,1))
			end do

			! 0:i,j	1:i+1,j
			txxt(0)	= txx(i1,j,1) + txx(i1,j,2)
			txxt(1)	= txx(i2,j,1) + txx(i2,j,2)
			do n = 0, 1		! 0:i,j		1:i,j-1
				txyt(n)	= txy(i1,j-n,1) + txy(i1,j-n,2)
			end do

			if((bc(i1,j,1) .eq. 3) .or. (bc(i1,j,1) .eq. 13)) then
				txxt(1)	= -txxt(0)
			end if
			if((bc(i2,j,1) .eq. -3) .or. (bc(i2,j,1) .eq. 13)) then
				txxt(0)	= -txxt(1)
			end if

			rw			= (rho(mi(i1,j)) * de(i1,j,1) + rho(mi(i2,j)) * de(i2,j,1)) / (de(i1,j,1) + de(i2,j,1))
			do n = 1, 2
				d(n)	= (de(i1,j,n) + de(i2,j,n)) / 2.0d0
			end do

			a1			= (1.0d0 - et(1)) / (1.0d0 + et(1))
			a2			= (dt * dble(tmul) / d(1)) / (rw * (1.0d0 + et(1)))

			if(distex .eq. 0) then
				if((sosel .eq. 1) .and. (i .eq. idr - 1) .and. (j .eq. jdr) .and. (t .le. tdr)) then
					if((bc(i+1,j,1) .eq. -3) .or. (bc(i+1,j,1) .eq. 13)) then
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) + tin(t) / d(2) * 2.0d0)
					else
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) + tin(t) / d(2) )
					end if
				elseif((sosel .eq. 2) .and. (i .eq. idr) .and. (j .eq. jdr) .and. (t .le. tdr)) then
					if((bc(i,j,1) .eq. 3) .or. (bc(i,j,1) .eq. 13)) then
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) - tin(t) / d(2)  * 2.0d0)
					else
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) - tin(t) / d(2) )
					end if
				else
					vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0))
				end if
			else
				if((sosel .eq. 1) .and. (i .eq. idr - 1) .and. (j .eq. jdr) .and. (t .le. tdr)) then
					if((bc(i+1,j,1) .eq. -3) .or. (bc(i+1,j,1) .eq. 13)) then
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) + tin(t) / d(2)  * 2.0d0 / 4.0d0)
					else
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) + tin(t) / d(2)  / 4.0d0)
					end if
				elseif((sosel .eq. 1) .and. (i .eq. idr - 1) .and. (j .eq. jdr + 1) .and. (t .le. tdr)) then
					if((bc(i+1,j,1) .eq. -3) .or. (bc(i+1,j,1) .eq. 13)) then
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) + tin(t) / d(2)  * 2.0d0 / 4.0d0)
					else
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) + tin(t) / d(2)  / 4.0d0)
					end if
				elseif((sosel .eq. 2) .and. (i .eq. idr) .and. (j .eq. jdr) .and. (t .le. tdr)) then
					if((bc(i,j,1) .eq. 3) .or. (bc(i,j,1) .eq. 13)) then
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) - tin(t) / d(2)  * 2.0d0 / 4.0d0)
					else
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) - tin(t) / d(2)  / 4.0d0)
					end if
				elseif((sosel .eq. 2) .and. (i .eq. idr) .and. (j .eq. jdr + 1) .and. (t .le. tdr)) then
					if((bc(i,j,1) .eq. 3) .or. (bc(i,j,1) .eq. 13)) then
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) - tin(t) / d(2)  * 2.0d0 / 4.0d0)
					else
						vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0) - tin(t) / d(2)  / 4.0d0)
					end if
				else
					vx(i,j,1)	= a1 * vx(i,j,1) + a2 * (txxt(1) - txxt(0))
				end if
			end if

			a1			= (1.0d0 - et(2)) / (1.0d0 + et(2))
			a2			= (dt * dble(tmul) / d(2)) / (rw * (1.0d0 + et(2)))
			vx(i,j,2)	= a1 * vx(i,j,2) + a2 * (txyt(0) - txyt(1))

			if(   (bc(i,j,1) .eq. 2) .or. (bc(i+1,j,1) .eq. -2) .or. (bc(i,j,1) .eq. 12) .or. (bc(i+1,j,1) .eq. 12)&
			 .or. (bc(i,j,1) .eq. 4) .or. (bc(i+1,j,1) .eq. -4) .or. (bc(i,j,1) .eq. 14) .or. (bc(i+1,j,1) .eq. 14)) then

				vx(i,j,1)	= 0.0d0
				vx(i,j,2)	= 0.0d0

			elseif((bc(i,j,1) .eq. 6) .or. (bc(i+1,j,1) .eq. -6) .or. (bc(i,j,1) .eq. 16) .or. (bc(i+1,j,1) .eq. 16)) then

				xx(i,j,1,1)	= (2.0d0 * rw - mck(msd(i,j,1), 1) / d(1) * dt * dble(tmul)) &
							/ (2.0d0 * rw + mck(msd(i,j,1), 1) / d(1) * dt * dble(tmul)) &
							* xx(i,j,1,1) + (2.0d0 * dt * dble(tmul) / d(1)) &
							/ (2.0d0 * rw + mck(msd(i,j,1), 1) / d(1) * dt * dble(tmul)) * (txxt(1) - txxt(0))
				xx(i,j,2,1)	= xx(i,j,2,1) + dt * dble(tmul) / mck(msd(i,j,1), 2) * (txxt(1) - txxt(0))
				vx(i,j,1)	= (xx(i,j,1,1) + xx(i,j,2,1)) * abs(sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0)))
				vx(i,j,2)	= 0.0d0

			elseif((bc(i,j,1) .eq. 7) .or. (bc(i,j,1) .eq. 17)) then

				vx(i,j,1)	= -txxt(0) / ((1.0d0 + sqrt(1.0d0 - mck(msd(i,j,1), 1))) / (1.0d0 - sqrt(1.0d0 - mck(msd(i,j,1), 1))) * rho(mi(i,j)) * sqrt(ca(mi(i,j),1) / rho(mi(i,j)))) * sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0))
				vx(i,j,2)	= 0.0d0

			elseif((bc(i+1,j,1) .eq. -7) .or. (bc(i+1,j,1) .eq. 17)) then

				vx(i,j,1)	= -txxt(1) / ((1.0d0 + sqrt(1.0d0 - mck(msd(i,j,1), 1))) / (1.0d0 - sqrt(1.0d0 - mck(msd(i,j,1), 1))) * rho(mi(i+1,j)) * sqrt(ca(mi(i+1,j),1) / rho(mi(i+1,j)))) * sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0))
				vx(i,j,2)	= 0.0d0

			elseif((bc(i,j,1) .eq. 8) .or. (bc(i+1,j,1) .eq. -8) .or. (bc(i,j,1) .eq. 18) .or. (bc(i+1,j,1) .eq. 18)) then

				ee1	= mck(msd(i,j,1), 4) * dt * dble(tmul)
				ee2	= mck(msd(i,j,1), 5) * dt * dble(tmul)
				gg1	= 2.0d0 * mck(msd(i,j,1), 6) * (dt * dble(tmul)) ** 2.0d0
				gg2	= 2.0d0 * mck(msd(i,j,1), 7) * (dt * dble(tmul)) ** 2.0d0
				m1p	= 2.0d0 * mck(msd(i,j,1), 1) + ee1
				m1m	= 2.0d0 * mck(msd(i,j,1), 1) - ee1
				nn1	= 4.0d0 * mck(msd(i,j,1), 1) - gg1
				aa1	= ee1 / m1p
				bb1	= aa1 * nn1
				ff1	= aa1 * m1m
				hh1	= aa1 - 1.0d0
				ii9	= ee1 * hh1 - ee2
				jj9	= gg1 * hh1 - gg2
				kk1	= bb1 + gg1
				ll1	= ff1 + ee1
				if(sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0)) .gt. 0.0d0) then
					xx(i,j,2,1)	= (-(jj9 + 4.0d0 * mck(msd(i,j,1), 2)) * xxp(i,j,2,1)&
								+ (ii9 + 2.0d0 * mck(msd(i,j,1), 2)) * xxpp(i,j,2,1)&
								- kk1 * xxp(i,j,1,1) + ll1 * xxpp(i,j,1,1)&
								- 2.0d0 * (dt * dble(tmul)) ** 2.0d0 * aa1 * (-txxt(0)))&
								/ (ii9 - 2.0d0 * mck(msd(i,j,1), 2))
					xx(i,j,1,1)	= (2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-txxt(0))&
								+ nn1 * xxp(i,j,1,1) - m1m * xxpp(i,j,1,1)&
								+ ee1 * xx(i,j,2,1) + gg1 * xxp(i,j,2,1) - ee1 * xxpp(i,j,2,1)) / m1p
					vx(i,j,1)	= (xx(i,j,1,1) - xxp(i,j,1,1)) / (dt * dble(tmul)) * sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0))
					vx(i,j,2)	= 0.0d0
					vx2(i,j)	= 0.0d0
				else
					xx(i,j,2,1)	= (-(jj9 + 4.0d0 * mck(msd(i,j,1), 2)) * xxp(i,j,2,1)&
								+ (ii9 + 2.0d0 * mck(msd(i,j,1), 2)) * xxpp(i,j,2,1)&
								- kk1 * xxp(i,j,1,1) + ll1 * xxpp(i,j,1,1)&
								- 2.0d0 * (dt * dble(tmul)) ** 2.0d0 * aa1 * (-txxt(1)))&
								/ (ii9 - 2.0d0 * mck(msd(i,j,1), 2))
					xx(i,j,1,1)	= (2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-txxt(1))&
								+ nn1 * xxp(i,j,1,1) - m1m * xxpp(i,j,1,1)&
								+ ee1 * xx(i,j,2,1) + gg1 * xxp(i,j,2,1) - ee1 * xxpp(i,j,2,1)) / m1p
					vx(i,j,1)	= 0.0d0
					vx(i,j,2)	= 0.0d0
					vx2(i,j)	= (xx(i,j,1,1) - xxp(i,j,1,1)) / (dt * dble(tmul)) * sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0))
				end if
				xxpp(i,j,1,1)		= xxp(i,j,1,1)
				xxp(i,j,1,1)		= xx(i,j,1,1)
				xxpp(i,j,2,1)		= xxp(i,j,2,1)
				xxp(i,j,2,1)		= xx(i,j,2,1)

			elseif((bc(i,j,1) .eq. 9) .or. (bc(i+1,j,1) .eq. -9) .or. (bc(i,j,1) .eq. 19) .or. (bc(i+1,j,1) .eq. 19)) then

				ee1	= mck(msd(i,j,1), 4) * dt * dble(tmul)
				ee2	= mck(msd(i,j,1), 5) * dt * dble(tmul)
				gg1	= 2.0d0 * mck(msd(i,j,1), 6) * (dt * dble(tmul)) ** 2.0d0
				gg2	= 2.0d0 * mck(msd(i,j,1), 7) * (dt * dble(tmul)) ** 2.0d0
				m1p	= 2.0d0 * mck(msd(i,j,1), 1) + ee1
				m1m	= 2.0d0 * mck(msd(i,j,1), 1) - ee1
				m3p	= 2.0d0 * mck(msd(i,j,1), 3) + ee2
				m3m	= 2.0d0 * mck(msd(i,j,1), 3) - ee2
				nn1	= 4.0d0 * mck(msd(i,j,1), 1) - gg1
				nn3	= 4.0d0 * mck(msd(i,j,1), 3) - gg2
				aa1	= ee1 / m1p
				aa3	= ee2 / m3p
				bb1	= aa1 * nn1
				bb3	= aa3 * nn3
				ff1	= aa1 * m1m
				ff3	= aa3 * m3m
				hh1	= aa1 - 1.0d0
				hh2	= aa3 - 1.0d0
				ii9	= ee1 * hh1 + ee2 * hh2
				jj9	= gg1 * hh1 + gg2 * hh2
				kk1	= bb1 + gg1
				kk3	= bb3 + gg2
				ll1	= ff1 + ee1
				ll3	= ff3 + ee2
				if(sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0)) .gt. 0.0d0) then
					xx(i,j,2,1)	= (-(jj9 + 4.0d0 * mck(msd(i,j,1), 2)) * xxp(i,j,2,1)&
								+ (ii9 + 2.0d0 * mck(msd(i,j,1), 2)) * xxpp(i,j,2,1)&
								- kk1 * xxp(i,j,1,1) + ll1 * xxpp(i,j,1,1)&
								- kk3 * xxp(i,j,3,1) + ll3 * xxpp(i,j,3,1)&
								+ 2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (aa3 * (-txxt(1)) - aa1 * (-txxt(0))))&
								/ (ii9 - 2.0d0 * mck(msd(i,j,1), 2))
					xx(i,j,1,1)	= (2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-txxt(0))&
								+ nn1 * xxp(i,j,1,1) - m1m * xxpp(i,j,1,1)&
								+ ee1 * xx(i,j,2,1) + gg1 * xxp(i,j,2,1) - ee1 * xxpp(i,j,2,1)) / m1p
					xx(i,j,3,1)	= (-2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-txxt(1))&
								+ nn3 * xxp(i,j,3,1) - m3m * xxpp(i,j,3,1)&
								+ ee2 * xx(i,j,2,1) + gg2 * xxp(i,j,2,1) - ee2 * xxpp(i,j,2,1)) / m3p
					vx(i,j,1)	= (xx(i,j,1,1) - xxp(i,j,1,1)) / (dt * dble(tmul)) * sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0))
					vx(i,j,2)	= 0.0d0
					vx2(i,j)	= (xx(i,j,3,1) - xxp(i,j,3,1)) / (dt * dble(tmul)) * sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0))
				else
					xx(i,j,2,1)	= (-(jj9 + 4.0d0 * mck(msd(i,j,1), 2)) * xxp(i,j,2,1)&
								+ (ii9 + 2.0d0 * mck(msd(i,j,1), 2)) * xxpp(i,j,2,1)&
								- kk1 * xxp(i,j,1,1) + ll1 * xxpp(i,j,1,1)&
								- kk3 * xxp(i,j,3,1) + ll3 * xxpp(i,j,3,1)&
								+ 2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (aa3 * (-txxt(0)) - aa1 * (-txxt(1))))&
								/ (ii9 - 2.0d0 * mck(msd(i,j,1), 2))
					xx(i,j,1,1)	= (2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-txxt(1))&
								+ nn1 * xxp(i,j,1,1) - m1m * xxpp(i,j,1,1)&
								+ ee1 * xx(i,j,2,1) + gg1 * xxp(i,j,2,1) - ee1 * xxpp(i,j,2,1)) / m1p
					xx(i,j,3,1)	= (-2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-txxt(0))&
								+ nn3 * xxp(i,j,3,1) - m3m * xxpp(i,j,3,1)&
								+ ee2 * xx(i,j,2,1) + gg2 * xxp(i,j,2,1) - ee2 * xxpp(i,j,2,1)) / m3p
					vx(i,j,1)	= (xx(i,j,3,1) - xxp(i,j,3,1)) / (dt * dble(tmul)) * sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0))
					vx(i,j,2)	= 0.0d0
					vx2(i,j)	= (xx(i,j,1,1) - xxp(i,j,1,1)) / (dt * dble(tmul)) * sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0))
				end if
				xxpp(i,j,1,1)		= xxp(i,j,1,1)
				xxp(i,j,1,1)		= xx(i,j,1,1)
				xxpp(i,j,2,1)		= xxp(i,j,2,1)
				xxp(i,j,2,1)		= xx(i,j,2,1)
				xxpp(i,j,3,1)		= xxp(i,j,3,1)
				xxp(i,j,3,1)		= xx(i,j,3,1)

			elseif((bc(i,j,1) .eq. 10) .or. (bc(i+1,j,1) .eq. -10) .or. (bc(i,j,1) .eq. 20) .or. (bc(i+1,j,1) .eq. 20)) then

				sigma	= acos(-1.0d0) * (mck(msd(i,j,1), 1) / 2.0d0 * mck(msd(i,j,1), 1) / 2.0d0) / (mck(msd(i,j,1), 2) * mck(msd(i,j,1), 2))
				Zresist	= 0.00289d0 * mck(msd(i,j,1), 1) ** (-1.82d0) * mck(msd(i,j,1), 3) + 7.72d0 * mck(msd(i,j,1), 1) ** 0.268d0
				Zreact	= mck(msd(i,j,1), 3) * ((4.0d0 / 3.0d0) + 0.85d0 * mck(msd(i,j,1), 1) / mck(msd(i,j,1), 3))

				xx(i,j,1,1)	= (2.0d0 * rw * Zreact - Zresist * dt * dble(tmul)) / (2.0d0 * rw * Zreact + Zresist * dt * dble(tmul)) * xx(i,j,1,1) + (2.0d0 * dt * dble(tmul)) / (2.0d0 * rw * Zreact + Zresist * dt * dble(tmul)) * (txxt(1) - txxt(0))
				xx(i,j,2,1)	= xx(i,j,2,1) + dt * dble(tmul) / mck(msd(i,j,1), 4) * (txxt(1) - txxt(0));
				vx(i,j,1)	= (sigma * xx(i,j,1,1) + xx(i,j,2,1)) * abs(sin(dble(ag(i,j,1)) / 36000.0d0 * acos(-1.0d0)))
				vx(i,j,2)	= 0.0d0

			end if

		end if
		end if

	end do
	end do

	! yqx
	!$omp parallel do private(i,j,tmul,n,et,tyyt,txyt,rw,d,a1,a2,j1,j2,ee1,ee2,gg1,gg2,m1p,m1m,m3p,m3m,nn1,nn3,aa1,aa3,bb1,bb3,ff1,ff3,hh1,hh2,ii9,jj9,kk1,kk3,ll1,ll3,sigma,Zresist,Zreact)
	do i = 1, irange
	do j = 0, jx

		j1	= j
		j2	= j + 1
		if((bc(i,j,2) .eq. 5) .or. (bc(i,j,2) .eq. 15)) then
			j2	= 1
		end if
		if((bc(i,j+1,2) .eq. -5) .or. (bc(i,j+1,2) .eq. 15)) then
			j1	= jx
		end if

		if(mi(i,j1) + mi(i,j2) .ne. 0) then
		tmul	= min(timeskip(mi(i,j1)), timeskip(mi(i,j2)))
		if(mod(t, tmul) .eq. 0) then

			do n = 1, 2
				et(n)	= (epv(i,j1,2,n) * de(i,j1,2) + epv(i,j2,2,n) * de(i,j2,2)) / (de(i,j1,2) + de(i,j2,2))
			end do

			! 0:i,j	1:i,j+1
			tyyt(0)	= tyy(i,j1,1) + tyy(i,j1,2)
			tyyt(1)	= tyy(i,j2,1) + tyy(i,j2,2)
			do n = 0, 1		! 0:i,j	1:i-1,j
				txyt(n)	= txy(i-n,j1,1) + txy(i-n,j1,2)
			end do

			if((bc(i,j1,2) .eq. 3) .or. (bc(i,j1,2) .eq. 13)) then
				tyyt(1)	= -tyyt(0)
			end if
			if((bc(i,j2,2) .eq. -3) .or. (bc(i,j2,2) .eq. 13)) then
				tyyt(0)	= -tyyt(1)
			end if

			rw			= (rho(mi(i,j1)) * de(i,j1,2) + rho(mi(i,j2)) * de(i,j2,2)) / (de(i,j1,2) + de(i,j2,2))
			do n = 1, 2
				d(n)	= (de(i,j1,n) + de(i,j2,n)) / 2.0d0
			end do

			a1			= (1.0d0 - et(1)) / (1.0d0 + et(1))
			a2			= (dt * dble(tmul) / d(1)) / (rw * (1.0d0 + et(1)))
			vy(i,j,1)	= a1 * vy(i,j,1) + a2 * (txyt(0) - txyt(1))

			a1			= (1.0d0 - et(2)) / (1.0d0 + et(2))
			a2			= (dt * dble(tmul) / d(2)) / (rw * (1.0d0 + et(2)))

			if(distex .eq. 0) then
				if((sosel .eq. 3) .and. (i .eq. idr) .and. (j .eq. jdr - 1) .and. (t .le. tdr)) then
					if((bc(i,j+1,2) .eq. -3) .or. (bc(i,j+1,2) .eq. 13)) then
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) + tin(t) / d(1) * 2.0d0)
					else
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) + tin(t) / d(1))
					end if
				elseif((sosel .eq. 4) .and. (i .eq. idr) .and. (j .eq. jdr) .and. (t .le. tdr)) then
					if((bc(i,j,2) .eq. 3) .or. (bc(i,j,2) .eq. 13)) then
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) - tin(t) / d(1) * 2.0d0)
					else
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) - tin(t) / d(1))
					end if
				else
					vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0))
				end if
			else
				if((sosel .eq. 3) .and. (i .eq. idr) .and. (j .eq. jdr - 1) .and. (t .le. tdr)) then
					if((bc(i,j+1,2) .eq. -3) .or. (bc(i,j+1,2) .eq. 13)) then
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) + tin(t) / d(1) * 2.0d0 / 4.0d0)
					else
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) + tin(t) / d(1) / 4.0d0)
					end if
				elseif((sosel .eq. 3) .and. (i .eq. idr + 1) .and. (j .eq. jdr - 1) .and. (t .le. tdr)) then
					if((bc(i,j+1,2) .eq. -3) .or. (bc(i,j+1,2) .eq. 13)) then
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) + tin(t) / d(1) * 2.0d0 / 4.0d0)
					else
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) + tin(t) / d(1) / 4.0d0)
					end if
				elseif((sosel .eq. 4) .and. (i .eq. idr) .and. (j .eq. jdr) .and. (t .le. tdr)) then
					if((bc(i,j,2) .eq. 3) .or. (bc(i,j,2) .eq. 13)) then
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) - tin(t) / d(1) * 2.0d0 / 4.0d0)
					else
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) - tin(t) / d(1) / 4.0d0)
					end if
				elseif((sosel .eq. 4) .and. (i .eq. idr + 1) .and. (j .eq. jdr) .and. (t .le. tdr)) then
					if((bc(i,j,2) .eq. 3) .or. (bc(i,j,2) .eq. 13)) then
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) - tin(t) / d(1) * 2.0d0 / 4.0d0)
					else
						vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0) - tin(t) / d(1) / 4.0d0)
					end if
				else
					vy(i,j,2)	= a1 * vy(i,j,2) + a2 * (tyyt(1) - tyyt(0))
				end if
			end if

			if(   (bc(i,j,2) .eq. 2) .or. (bc(i,j+1,2) .eq. -2) .or. (bc(i,j,2) .eq. 12) .or. (bc(i,j+1,2) .eq. 12)&
			 .or. (bc(i,j,2) .eq. 4) .or. (bc(i,j+1,2) .eq. -4) .or. (bc(i,j,2) .eq. 14) .or. (bc(i,j+1,2) .eq. 14)) then

				vy(i,j,1)	= 0.0d0
				vy(i,j,2)	= 0.0d0

			elseif((bc(i,j,2) .eq. 6) .or. (bc(i,j+1,2) .eq. -6) .or. (bc(i,j,2) .eq. 16) .or. (bc(i,j+1,2) .eq. 16)) then

				xx(i,j,1,2)	= (2.0d0 * rw - mck(msd(i,j,2), 1) / d(2) * dt * dble(tmul)) &
							/ (2.0d0 * rw + mck(msd(i,j,2), 1) / d(2) * dt * dble(tmul)) &
							* xx(i,j,1,2) + (2.0d0 * dt * dble(tmul) / d(2)) &
							/ (2.0d0 * rw + mck(msd(i,j,2), 1) / d(2) * dt * dble(tmul)) * (tyyt(1) - tyyt(0))
				xx(i,j,2,2)	= xx(i,j,2,2) + dt * dble(tmul) / mck(msd(i,j,2), 2) * (tyyt(1) - tyyt(0))
				vy(i,j,1)	= 0.0d0
				vy(i,j,2)	= (xx(i,j,1,2) + xx(i,j,2,2)) * abs(sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0)))

			elseif((bc(i,j,2) .eq. 7) .or. (bc(i,j,2) .eq. 17)) then

				vy(i,j,1)	= 0.0d0
				vy(i,j,2)	= -tyyt(0) / ((1.0d0 + sqrt(1.0d0 - mck(msd(i,j,2), 1))) / (1.0d0 - sqrt(1.0d0 - mck(msd(i,j,2), 1))) * rho(mi(i,j)) * sqrt(ca(mi(i,j),2) / rho(mi(i,j)))) * sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0))

			elseif((bc(i,j+1,2) .eq. -7) .or. (bc(i,j+1,2) .eq. 17)) then

				vy(i,j,1)	= 0.0d0
				vy(i,j,2)	= -tyyt(1) / ((1.0d0 + sqrt(1.0d0 - mck(msd(i,j,2), 1))) / (1.0d0 - sqrt(1.0d0 - mck(msd(i,j,2), 1))) * rho(mi(i,j+1)) * sqrt(ca(mi(i,j+1),2) / rho(mi(i,j+1)))) * sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0))

			elseif((bc(i,j,2) .eq. 8) .or. (bc(i,j+1,2) .eq. -8) .or. (bc(i,j,2) .eq. 18) .or. (bc(i,j+1,2) .eq. 18)) then

				ee1	= mck(msd(i,j,2), 4) * dt * dble(tmul)
				ee2	= mck(msd(i,j,2), 5) * dt * dble(tmul)
				gg1	= 2.0d0 * mck(msd(i,j,2), 6) * (dt * dble(tmul)) ** 2.0d0
				gg2	= 2.0d0 * mck(msd(i,j,2), 7) * (dt * dble(tmul)) ** 2.0d0
				m1p	= 2.0d0 * mck(msd(i,j,2), 1) + ee1
				m1m	= 2.0d0 * mck(msd(i,j,2), 1) - ee1
				nn1	= 4.0d0 * mck(msd(i,j,2), 1) - gg1
				aa1	= ee1 / m1p
				bb1	= aa1 * nn1
				ff1	= aa1 * m1m
				hh1	= aa1 - 1.0d0
				ii9	= ee1 * hh1 - ee2
				jj9	= gg1 * hh1 - gg2
				kk1	= bb1 + gg1
				ll1	= ff1 + ee1
				if(sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0)) .gt. 0.0d0) then
					xx(i,j,2,2)	= (-(jj9 + 4.0d0 * mck(msd(i,j,2), 2)) * xxp(i,j,2,2)&
								+ (ii9 + 2.0d0 * mck(msd(i,j,2), 2)) * xxpp(i,j,2,2)&
								- kk1 * xxp(i,j,1,2) + ll1 * xxpp(i,j,1,2)&
								- 2.0d0 * (dt * dble(tmul)) ** 2.0d0 * aa1 * (-tyyt(0)))&
								/ (ii9 - 2.0d0 * mck(msd(i,j,2), 2))
					xx(i,j,1,2)	= (2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-tyyt(0))&
								+ nn1 * xxp(i,j,1,2) - m1m * xxpp(i,j,1,2)&
								+ ee1 * xx(i,j,2,2) + gg1 * xxp(i,j,2,2) - ee1 * xxpp(i,j,2,2)) / m1p
					vy(i,j,1)	= 0.0d0
					vy(i,j,2)	= (xx(i,j,1,2) - xxp(i,j,1,2)) / (dt * dble(tmul)) * sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0))
					vy2(i,j)	= 0.0d0
				else
					xx(i,j,2,2)	= (-(jj9 + 4.0d0 * mck(msd(i,j,2), 2)) * xxp(i,j,2,2)&
								+ (ii9 + 2.0d0 * mck(msd(i,j,2), 2)) * xxpp(i,j,2,2)&
								- kk1 * xxp(i,j,1,2) + ll1 * xxpp(i,j,1,2)&
								- 2.0d0 * (dt * dble(tmul)) ** 2.0d0 * aa1 * (-tyyt(1)))&
								/ (ii9 - 2.0d0 * mck(msd(i,j,2), 2))
					xx(i,j,1,2)	= (2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-tyyt(1))&
								+ nn1 * xxp(i,j,1,2) - m1m * xxpp(i,j,1,2)&
								+ ee1 * xx(i,j,2,2) + gg1 * xxp(i,j,2,2) - ee1 * xxpp(i,j,2,2)) / m1p
					vy(i,j,1)	= 0.0d0
					vy(i,j,2)	= 0.0d0
					vy2(i,j)	= (xx(i,j,1,2) - xxp(i,j,1,2)) / (dt * dble(tmul)) * sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0))
				end if
				xxpp(i,j,1,2)	= xxp(i,j,1,2)
				xxp(i,j,1,2)	= xx(i,j,1,2)
				xxpp(i,j,2,2)	= xxp(i,j,2,2)
				xxp(i,j,2,2)	= xx(i,j,2,2)

			elseif((bc(i,j,2) .eq. 9) .or. (bc(i,j+1,2) .eq. -9) .or. (bc(i,j,2) .eq. 19) .or. (bc(i,j+1,2) .eq. 19)) then

				ee1	= mck(msd(i,j,2), 4) * dt * dble(tmul)
				ee2	= mck(msd(i,j,2), 5) * dt * dble(tmul)
				gg1	= 2.0d0 * mck(msd(i,j,2), 6) * (dt * dble(tmul)) ** 2.0d0
				gg2	= 2.0d0 * mck(msd(i,j,2), 7) * (dt * dble(tmul)) ** 2.0d0
				m1p	= 2.0d0 * mck(msd(i,j,2), 1) + ee1
				m1m	= 2.0d0 * mck(msd(i,j,2), 1) - ee1
				m3p	= 2.0d0 * mck(msd(i,j,2), 3) + ee2
				m3m	= 2.0d0 * mck(msd(i,j,2), 3) - ee2
				nn1	= 4.0d0 * mck(msd(i,j,2), 1) - gg1
				nn3	= 4.0d0 * mck(msd(i,j,2), 3) - gg2
				aa1	= ee1 / m1p
				aa3	= ee2 / m3p
				bb1	= aa1 * nn1
				bb3	= aa3 * nn3
				ff1	= aa1 * m1m
				ff3	= aa3 * m3m
				hh1	= aa1 - 1.0d0
				hh2	= aa3 - 1.0d0
				ii9	= ee1 * hh1 + ee2 * hh2
				jj9	= gg1 * hh1 + gg2 * hh2
				kk1	= bb1 + gg1
				kk3	= bb3 + gg2
				ll1	= ff1 + ee1
				ll3	= ff3 + ee2
				if(sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0)) .gt. 0.0d0) then
					xx(i,j,2,2)	= (-(jj9 + 4.0d0 * mck(msd(i,j,2), 2)) * xxp(i,j,2,2)&
								+ (ii9 + 2.0d0 * mck(msd(i,j,2), 2)) * xxpp(i,j,2,2)&
								- kk1 * xxp(i,j,1,2) + ll1 * xxpp(i,j,1,2)&
								- kk3 * xxp(i,j,3,2) + ll3 * xxpp(i,j,3,2)&
								+ 2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (aa3 * (-tyyt(1)) - aa1 * (-tyyt(0))))&
								/ (ii9 - 2.0d0 * mck(msd(i,j,2), 2))
					xx(i,j,1,2)	= (2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-tyyt(0))&
								+ nn1 * xxp(i,j,1,2) - m1m * xxpp(i,j,1,2)&
								+ ee1 * xx(i,j,2,2) + gg1 * xxp(i,j,2,2) - ee1 * xxpp(i,j,2,2)) / m1p
					xx(i,j,3,2)	= (-2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-tyyt(1))&
								+ nn3 * xxp(i,j,3,2) - m3m * xxpp(i,j,3,2)&
								+ ee2 * xx(i,j,2,2) + gg2 * xxp(i,j,2,2) - ee2 * xxpp(i,j,2,2)) / m3p
					vy(i,j,1)	= 0.0d0
					vy(i,j,2)	= (xx(i,j,1,2) - xxp(i,j,1,2)) / (dt * dble(tmul)) * sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0))
					vy2(i,j)	= (xx(i,j,3,2) - xxp(i,j,3,2)) / (dt * dble(tmul)) * sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0))
				else
					xx(i,j,2,2)	= (-(jj9 + 4.0d0 * mck(msd(i,j,2), 2)) * xxp(i,j,2,2)&
								+ (ii9 + 2.0d0 * mck(msd(i,j,2), 2)) * xxpp(i,j,2,2)&
								- kk1 * xxp(i,j,1,2) + ll1 * xxpp(i,j,1,2)&
								- kk3 * xxp(i,j,3,2) + ll3 * xxpp(i,j,3,2)&
								+ 2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (aa3 * (-tyyt(0)) - aa1 * (-tyyt(1))))&
								/ (ii9 - 2.0d0 * mck(msd(i,j,2), 2))
					xx(i,j,1,2)	= (2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-tyyt(1))&
								+ nn1 * xxp(i,j,1,2) - m1m * xxpp(i,j,1,2)&
								+ ee1 * xx(i,j,2,2) + gg1 * xxp(i,j,2,2) - ee1 * xxpp(i,j,2,2)) / m1p
					xx(i,j,3,2)	= (-2.0d0 * (dt * dble(tmul)) ** 2.0d0 * (-tyyt(0))&
								+ nn3 * xxp(i,j,3,2) - m3m * xxpp(i,j,3,2)&
								+ ee2 * xx(i,j,2,2) + gg2 * xxp(i,j,2,2) - ee2 * xxpp(i,j,2,2)) / m3p
					vy(i,j,1)	= 0.0d0
					vy(i,j,2)	= (xx(i,j,3,2) - xxp(i,j,3,2)) / (dt * dble(tmul)) * sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0))
					vy2(i,j)	= (xx(i,j,1,2) - xxp(i,j,1,2)) / (dt * dble(tmul)) * sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0))
				end if
				xxpp(i,j,1,2)	= xxp(i,j,1,2)
				xxp(i,j,1,2)	= xx(i,j,1,2)
				xxpp(i,j,2,2)	= xxp(i,j,2,2)
				xxp(i,j,2,2)	= xx(i,j,2,2)
				xxpp(i,j,3,2)	= xxp(i,j,3,2)
				xxp(i,j,3,2)	= xx(i,j,3,2)

			elseif((bc(i,j,2) .eq. 10) .or. (bc(i,j+1,2) .eq. -10) .or. (bc(i,j,2) .eq. 20) .or. (bc(i,j+1,2) .eq. 20)) then

				sigma	= acos(-1.0d0) * (mck(msd(i,j,2), 1) / 2.0d0 * mck(msd(i,j,2), 1) / 2.0d0) / (mck(msd(i,j,2), 2) * mck(msd(i,j,2), 2))
				Zresist	= 0.00289d0 * mck(msd(i,j,2), 1) ** (-1.82d0) * mck(msd(i,j,2), 3) + 7.72d0 * mck(msd(i,j,2), 1) ** 0.268d0
				Zreact	= mck(msd(i,j,2), 3) * ((4.0d0 / 3.0d0) + 0.85d0 * mck(msd(i,j,2), 1) / mck(msd(i,j,2), 3))

				xx(i,j,1,2)	= (2.0d0 * rw * Zreact - Zresist * dt * dble(tmul)) / (2.0d0 * rw * Zreact + Zresist * dt * dble(tmul)) * xx(i,j,1,2) + (2.0d0 * dt * dble(tmul)) / (2.0d0 * rw * Zreact + Zresist * dt * dble(tmul)) * (tyyt(1) - tyyt(0))
				xx(i,j,2,2)	= xx(i,j,2,2) + dt * dble(tmul) / mck(msd(i,j,2), 4) * (tyyt(1) - tyyt(0));
				vy(i,j,1)	= 0.0d0
				vy(i,j,2)	= (sigma * xx(i,j,1,2) + xx(i,j,2,2)) * abs(sin(dble(ag(i,j,2)) / 36000.0d0 * acos(-1.0d0)))

			end if

		end if
		end if

	end do
	end do

	! ͍XV
	!$omp parallel do private(i,j,tmul,n,v,m,rr,a)
	do i = 1, irange
	do j = 1, jx

		if(mi(i,j) .ne. 0) then
		tmul	= timeskip(mi(i,j))
		if(mod(t, tmul) .eq. 0) then

			! 0:i,j	1:i-1,j/i,j-1
			v(0,1)	= vx(i,j,1) + vx(i,j,2)
			v(0,2)	= vy(i,j,1) + vy(i,j,2)
			if((bc(i,j,1) .eq. -8) .or. (bc(i,j,1) .eq. 18) .or. (bc(i,j,1) .eq. -9) .or. (bc(i,j,1) .eq. 19)) then
				v(1,1)	= vx2(i-1,j)
			else
				v(1,1)	= vx(i-1,j,1) + vx(i-1,j,2)
			end if
			if((bc(i,j,2) .eq. -8) .or. (bc(i,j,2) .eq. 18) .or. (bc(i,j,2) .eq. -9) .or. (bc(i,j,2) .eq. 19)) then
				v(1,2)	= vy2(i,j-1)
			else
				v(1,2)	= vy(i,j-1,1) + vy(i,j-1,2)
			end if

			do m = 1, 2
				if((outputSelect .eq. 0) .or. (outputSelect .eq. 1)) then
					uc(i,j,m)	= uc(i,j,m) + (v(0,m) + v(1,m)) / 2.0d0 * dt * dble(tmul)
				end if
				rr(m)	= (v(0,m) - v(1,m)) / de(i,j,m)
				a(1,m)	= (1.0d0 - ept(i,j,m)) / (1.0d0 + ept(i,j,m))
				a(2,m)	= 1.0d0 / (1.0d0 + ept(i,j,m))
			end do

			txx(i,j,1)	= a(1,1) * txx(i,j,1) + dt * dble(tmul) * ca(mi(i,j),1) * a(2,1) * rr(1) + xa(mi(i,j),1) * a(2,1) * (rr(1) - rrp(i,j,1))
			txx(i,j,2)	= a(1,2) * txx(i,j,2) + dt * dble(tmul) * cb(mi(i,j))   * a(2,2) * rr(2) + xb(mi(i,j))   * a(2,2) * (rr(2) - rrp(i,j,2))
			tyy(i,j,1)	= a(1,1) * tyy(i,j,1) + dt * dble(tmul) * cb(mi(i,j))   * a(2,1) * rr(1) + xb(mi(i,j))   * a(2,1) * (rr(1) - rrp(i,j,1))
			tyy(i,j,2)	= a(1,2) * tyy(i,j,2) + dt * dble(tmul) * ca(mi(i,j),2) * a(2,2) * rr(2) + xa(mi(i,j),1) * a(2,2) * (rr(2) - rrp(i,j,2))

			if((sosel .eq. 0) .and. (i .eq. idr) .and. (j .eq. jdr)) then
				txx(i,j,1)	= txx(i,j,1) - 2.0d0 * acos(-1.0d0) * (dt * dble(tmul)) ** 2.0d0 * ca(mi(i,j),1) / rho(mi(i,j)) * tinsum(t) / 2.0d0 / de(i,j,1) / de(i,j,2) * sqrt(de(i,j,1) * de(i,j,2) / acos(-1.0d0))
				txx(i,j,2)	= txx(i,j,2) - 2.0d0 * acos(-1.0d0) * (dt * dble(tmul)) ** 2.0d0 * cb(mi(i,j)) / rho(mi(i,j))   * tinsum(t) / 2.0d0 / de(i,j,1) / de(i,j,2) * sqrt(de(i,j,1) * de(i,j,2) / acos(-1.0d0))
				tyy(i,j,1)	= tyy(i,j,1) - 2.0d0 * acos(-1.0d0) * (dt * dble(tmul)) ** 2.0d0 * cb(mi(i,j)) / rho(mi(i,j))   * tinsum(t) / 2.0d0 / de(i,j,1) / de(i,j,2) * sqrt(de(i,j,1) * de(i,j,2) / acos(-1.0d0))
				tyy(i,j,2)	= tyy(i,j,2) - 2.0d0 * acos(-1.0d0) * (dt * dble(tmul)) ** 2.0d0 * ca(mi(i,j),2) / rho(mi(i,j)) * tinsum(t) / 2.0d0 / de(i,j,1) / de(i,j,2) * sqrt(de(i,j,1) * de(i,j,2) / acos(-1.0d0))
			end if

			rrp(i,j,1)	= rr(1)
			rrp(i,j,2)	= rr(2)

			navu(i,j)		= navu(i,j) - (cb(mi(i,j)) + 2.0d0 * cc(mi(i,j)) / 3.0d0) * (rr(1) + rr(2)) * dt * dble(tmul)
			if((sosel .eq. 0) .and. (i .eq. idr) .and. (j .eq. jdr)) then
				navu(i,j)	= navu(i,j) + 2.0d0 * acos(-1.0d0) * (dt * dble(tmul)) ** 2.0d0 * (cb(mi(i,j)) + 2.0d0 * cc(mi(i,j)) / 3.0d0) / rho(mi(i,j)) * tinsum(t) / de(i,j,1) / de(i,j,2) * sqrt(de(i,j,1) * de(i,j,2) / acos(-1.0d0))
			end if

			if((outputSelect .eq. 0) .or. (outputSelect .eq. 1)) then
				do ii = 0, rptCount - 1
					if((i .eq. rpti(ii)) .and. (j .eq. rptj(ii))) then
						if(rpts(ii) .eq. 0) then
							write(11+ii,rec=t/tmul) navu(i,j)
						elseif(rpts(ii) .eq. 1) then
							write(11+ii,rec=t/tmul) (v(0,1) + v(1,1)) / 2.0d0
						elseif(rpts(ii) .eq. 2) then
							write(11+ii,rec=t/tmul) (v(0,2) + v(1,2)) / 2.0d0
						elseif(rpts(ii) .eq. 3) then
							write(11+ii,rec=t/tmul) txx(i,j,1) + txx(i,j,2)
						elseif(rpts(ii) .eq. 4) then
							write(11+ii,rec=t/tmul) tyy(i,j,1) + tyy(i,j,2)
						elseif(rpts(ii) .eq. 5) then
							write(11+ii,rec=t/tmul) (txy(i-1,j-1,1) + txy(i-1,j-1,2) + txy(i,j-1,1) + txy(i,j-1,2) + txy(i-1,j,1) + txy(i-1,j,2) + txy(i,j,1) + txy(i,j,2)) / 4.0d0
						end if
					end if
				end do
			end if

		end if
		end if

	end do
	end do

	if((outputSelect .eq. 0) .or. (outputSelect .eq. 2)) then

		! ψʍXV
		!$omp parallel do private(i,j,tmul) 
		do i = 0, irange
		do j = 1, jx
			tmul		= timeskip(mi(i,j))
			u(i,j,1)	= u(i,j,1) + (vx(i,j,1) + vx(i,j,2)) * dt * dble(tmul)
		end do
		end do

		!$omp parallel do private(i,j,tmul) 
		do i = 1, irange
		do j = 0, jx
			tmul		= timeskip(mi(i,j))
			u(i,j,2)	= u(i,j,2) + (vy(i,j,1) + vy(i,j,2)) * dt * dble(tmul)
		end do
		end do

	end if

	! f͍XV
	! xyʂf
	!$omp parallel do private(i,j,tmul,n,v,vpp,s,mu,ka,m,ext,del,mt,d,exy,mxy,xic,a,i1,i2,j1,j2)
	do i = 0, irange
	do j = 0, jx

		i1	= i
		i2	= i + 1
		j1	= j
		j2	= j + 1
		if((bc(i,j,1) .eq. 5) .or. (bc(i,j,1) .eq. 15)) then
			i2	= 1
		end if
		if((bc(i+1,j,1) .eq. -5) .or. (bc(i+1,j,1) .eq. 15)) then
			i1	= irange
		end if
		if((bc(i,j,2) .eq. 5) .or. (bc(i,j,2) .eq. 15)) then
			j2	= 1
		end if
		if((bc(i,j+1,2) .eq. -5) .or. (bc(i,j+1,2) .eq. 15)) then
			j1	= jx
		end if

		if(mi(i1,j1) + mi(i2,j1) + mi(i1,j2) + mi(i2,j2) .ne. 0) then
		tmul	= min(timeskip(mi(i1,j1)), timeskip(mi(i2,j1)), timeskip(mi(i1,j2)), timeskip(mi(i2,j2)))
		if(mod(t, tmul) .eq. 0) then

			! 0:i,j	1:i,j+1/i+1,j
			v(0,1)		= vx(i1,j1,1) + vx(i1,j1,2)
			v(0,2)		= vy(i1,j1,1) + vy(i1,j1,2)
			v(1,1)		= vx(i1,j2,1) + vx(i1,j2,2)
			v(1,2)		= vy(i2,j1,1) + vy(i2,j1,2)
			vpp(0,1)	= vp(i1,j1,1)
			vpp(0,2)	= vp(i1,j1,2)
			vpp(1,1)	= vp(i1,j2,1)
			vpp(1,2)	= vp(i2,j1,2)

			if((bc(i1,j1,2) .eq.  2) .or. (bc(i2,j1,2) .eq.  2) .or. (bc(i1,j1,2) .eq. 12) .or. (bc(i2,j1,2) .eq. 12)) then
				v(1,1)		= -v(0,1)
				vpp(1,1)	= -vpp(0,1)
			end if
			if((bc(i1,j2,2) .eq. -2) .or. (bc(i2,j2,2) .eq. -2) .or. (bc(i1,j2,2) .eq. 12) .or. (bc(i2,j2,2) .eq. 12)) then
				v(0,1)		= -v(1,1)
				vpp(0,1)	= -vpp(1,1)
			end if
			if((bc(i1,j1,1) .eq.  2) .or. (bc(i1,j2,1) .eq.  2) .or. (bc(i1,j1,1) .eq. 12) .or. (bc(i1,j2,1) .eq. 12)) then
				v(1,2)		= -v(0,2)
				vpp(1,2)	= -vpp(0,2)
			end if
			if((bc(i2,j1,1) .eq. -2) .or. (bc(i2,j2,1) .eq. -2) .or. (bc(i2,j1,1) .eq. 12) .or. (bc(i2,j2,1) .eq. 12)) then
				v(0,2)		= -v(1,2)
				vpp(0,2)	= -vpp(1,2)
			end if

			! 00:i,j	01:i,j+1	10:i+1,j	11:i+1,j+1
			mu(0,0)			= cc(mi(i1,j1))
			if(pi(i1,j1) .eq. 1) then
				ka(0,0)		= xc(mi(i1,j1))
			else
				ka(0,0)		= 0.0d0
			end if
			do m = 1, 2
				ext(0,0,m)	= ept(i1,j1,m)
				del(0,m)	= de(i1,j1,m)
			end do
			if(mi(i1,j1) .eq. 0) then
				mt(0,0)		= 0.0d0
			else
				mt(0,0)		= 1.0d0
			end if

			mu(0,1)			= cc(mi(i1,j2))
			if(pi(i1,j2) .eq. 1) then
				ka(0,1)		= xc(mi(i1,j2))
			else
				ka(0,1)		= 0.0d0
			end if
			do m = 1, 2
				ext(0,1,m)	= ept(i1,j2,m)
				del(0,m)	= de(i1,j1,m)
			end do
			if(mi(i1,j2) .eq. 0) then
				mt(0,1)		= 0.0d0
			else
				mt(0,1)		= 1.0d0
			end if

			mu(1,0)			= cc(mi(i2,j1))
			if(pi(i2,j1) .eq. 1) then
				ka(1,0)		= xc(mi(i2,j1))
			else
				ka(1,0)		= 0.0d0
			end if
			do m = 1, 2
				ext(1,0,m)	= ept(i2,j1,m)
				del(1,m)	= de(i2,j2,m)
			end do
			if(mi(i2,j1) .eq. 0) then
				mt(1,0)		= 0.0d0
			else
				mt(1,0)		= 1.0d0
			end if

			mu(1,1)			= cc(mi(i2,j2))
			if(pi(i2,j2) .eq. 1) then
				ka(1,1)		= xc(mi(i2,j2))
			else
				ka(1,1)		= 0.0d0
			end if
			do m = 1, 2
				ext(1,1,m)	= ept(i2,j2,m)
				del(1,m)	= de(i2,j2,m)
			end do
			if(mi(i2,j2) .eq. 0) then
				mt(1,1)		= 0.0d0
			else
				mt(1,1)		= 1.0d0
			end if

			d(1)	= (de(i1,j1,1) + de(i2,j1,1)) / 2.0d0
			d(2)	= (de(i1,j1,2) + de(i1,j2,2)) / 2.0d0

			do m = 1, 2
				if(ext(0,0,m) * ext(1,0,m) * ext(0,1,m) * ext(1,1,m) .ne. 0.0d0) then
					exy(m)	= ((del(0,1) + del(1,1)) * (del(0,2) + del(1,2)))&
							/ (mt(0,0)*del(0,1)*del(0,2)/ext(0,0,m) + mt(1,0)*del(1,1)*del(0,2)/ext(1,0,m)&
							+  mt(0,1)*del(0,1)*del(1,2)/ext(0,1,m) + mt(1,1)*del(1,1)*del(1,2)/ext(1,1,m))
				else
					exy(m)	= 0.0d0
				end if
			end do

			if(mu(0,0) * mu(1,0) * mu(0,1) * mu(1,1) .ne. 0.0d0) then
				mxy		= ((del(0,1) + del(1,1)) * (del(0,2) + del(1,2)))&
						/ (mt(0,0)*del(0,1)*del(0,2)/mu(0,0) + mt(1,0)*del(1,1)*del(0,2)/mu(1,0)&
						+  mt(0,1)*del(0,1)*del(1,2)/mu(0,1) + mt(1,1)*del(1,1)*del(1,2)/mu(1,1))
			else
				mxy		= 0.0d0
			end if

			if(ka(0,0) * ka(1,0) * ka(0,1) * ka(1,1) .ne. 0.0d0) then
				xic		= ((del(0,1) + del(1,1)) * (del(0,2) + del(1,2)))&
						/ (mt(0,0)*del(0,1)*del(0,2)/ka(0,0) + mt(1,0)*del(1,1)*del(0,2)/ka(1,0)&
						+  mt(0,1)*del(0,1)*del(1,2)/ka(0,1) + mt(1,1)*del(1,1)*del(1,2)/ka(1,1))
			else
				xic		= 0.0d0
			end if

			a(1,1)	= (1.0d0 - exy(1)) / (1.0d0 + exy(1))
			a(2,1)	= (dt * dble(tmul) / d(1)) * mxy / (1.0d0 + exy(1))
			a(3,1)	= (1.0d0 / d(1)) * xic / (1.0d0 + exy(1))
			a(1,2)	= (1.0d0 - exy(2)) / (1.0d0 + exy(2))
			a(2,2)	= (dt * dble(tmul) / d(2)) * mxy / (1.0d0 + exy(2))
			a(3,2)	= (1.0d0 / d(2)) * xic / (1.0d0 + exy(2))

			txy(i,j,1)	= a(1,1) * txy(i,j,1) + a(2,1) * (v(1,2) - v(0,2)) + a(3,1) * ((v(1,2) - v(0,2)) - (vpp(1,2) - vpp(0,2)))
			txy(i,j,2)	= a(1,2) * txy(i,j,2) + a(2,2) * (v(1,1) - v(0,1)) + a(3,2) * ((v(1,1) - v(0,1)) - (vpp(1,1) - vpp(0,1)))

			if(   (bc(i,j,1) .eq.  3) .or. (bc(i,j+1,1) .eq.  3) .or. (bc(i+1,j,1) .eq. -3) .or. (bc(i+1,j+1,1) .eq. -3)&
			 .or. (bc(i,j,2) .eq.  3) .or. (bc(i+1,j,2) .eq.  3) .or. (bc(i,j+1,2) .eq. -3) .or. (bc(i+1,j+1,2) .eq. -3)&
			 .or. (bc(i,j,1) .eq. 13) .or. (bc(i,j+1,1) .eq. 13) .or. (bc(i+1,j,1) .eq. 13) .or. (bc(i+1,j+1,1) .eq. 13)&
			 .or. (bc(i,j,2) .eq. 13) .or. (bc(i+1,j,2) .eq. 13) .or. (bc(i,j+1,2) .eq. 13) .or. (bc(i+1,j+1,2) .eq. 13)&
			 .or. (bc(i,j,1) .eq.  4) .or. (bc(i,j+1,1) .eq.  4) .or. (bc(i+1,j,1) .eq. -4) .or. (bc(i+1,j+1,1) .eq. -4)&
			 .or. (bc(i,j,2) .eq.  4) .or. (bc(i+1,j,2) .eq.  4) .or. (bc(i,j+1,2) .eq. -4) .or. (bc(i+1,j+1,2) .eq. -4)&
			 .or. (bc(i,j,1) .eq. 14) .or. (bc(i,j+1,1) .eq. 14) .or. (bc(i+1,j,1) .eq. 14) .or. (bc(i+1,j+1,1) .eq. 14)&
			 .or. (bc(i,j,2) .eq. 14) .or. (bc(i+1,j,2) .eq. 14) .or. (bc(i,j+1,2) .eq. 14) .or. (bc(i+1,j+1,2) .eq. 14)&
			 .or. (bc(i,j,1) .eq.  7) .or. (bc(i,j+1,1) .eq.  7) .or. (bc(i+1,j,1) .eq. -7) .or. (bc(i+1,j+1,1) .eq. -7)&
			 .or. (bc(i,j,2) .eq.  7) .or. (bc(i+1,j,2) .eq.  7) .or. (bc(i,j+1,2) .eq. -7) .or. (bc(i+1,j+1,2) .eq. -7)&
			 .or. (bc(i,j,1) .eq. 17) .or. (bc(i,j+1,1) .eq. 17) .or. (bc(i+1,j,1) .eq. 17) .or. (bc(i+1,j+1,1) .eq. 17)&
			 .or. (bc(i,j,2) .eq. 17) .or. (bc(i+1,j,2) .eq. 17) .or. (bc(i,j+1,2) .eq. 17) .or. (bc(i+1,j+1,2) .eq. 17)) then
				txy(i,j,1)	= 0.0d0
				txy(i,j,2)	= 0.0d0
			end if

		end if
		end if

	end do
	end do

	! Oԗqxۑ
	!$omp parallel do private(i,j,tmul)
	do i = 0, irange
	do j = 0, jx + 1
		tmul	= min(timeskip(mi(i,j)), timeskip(mi(i+1,j)))
		if(mod(t, tmul) .eq. 0) vp(i,j,1)	= vx(i,j,1) + vx(i,j,2)
	end do
	end do

	!$omp parallel do private(i,j,tmul)
	do i = 0, irange + 1
	do j = 0, jx
		tmul	= min(timeskip(mi(i,j)), timeskip(mi(i,j+1)))
		if(mod(t, tmul) .eq. 0) vp(i,j,2)	= vy(i,j,1) + vy(i,j,2)
	end do
	end do

	! zt@C

	if((outputSelect .eq. 0) .or. (outputSelect .eq. 1)) then
		! Uo͏
		if(mod(t, dframe) .eq. 0) then

			if (srfCount .ge. 1) then

				write(srfstr,'(i1)') 0

				! t@Cl[
				write(str,'("_", a, "_", i8.8)') trim(srfstr), t

				! t@C xy
				open(1,file='output/matlab/surf/'//trim(fn)//'_p'//trim(str),access='direct',status='replace',recl=8)
				do i = 1, irange
				do j = 1, jx
					if((cc(mi(i,j)) .eq. 0.0d0) .and. (mi(i,j) .ne. 0)) then
						write(1,rec=(i-1)*jx+j) navu(i,j)
					else
						write(1,rec=(i-1)*jx+j)	1.0d30
					end if
				end do
				end do
				close(1)

				! ψʃt@C xy
				open(1,file='output/matlab/surf/'//trim(fn)//'_u'//trim(str),access='direct',status='replace',recl=8)
				iii	= 0
				tmpx	= -de(1,1,1) / 2.0d0
				do i = 1, irange
				tmpx	= tmpx + de(i,1,1) / 2.0d0 + de(i-1,1,1) / 2.0d0
				tmpy	= -de(1,1,2) / 2.0d0
				do j = 1, jx
					tmpy	= tmpy + de(1,j,2) / 2.0d0 + de(1,j-1,2) / 2.0d0
					if((mi(i,j) .ne. 0) .and. (cc(mi(i,j)) .ne. 0.0d0)) then
						write(1,rec=iii*4+1) tmpx + pmlMinX
						write(1,rec=iii*4+2) tmpy + pmlMinY
						write(1,rec=iii*4+3) uc(i,j,1)
						write(1,rec=iii*4+4) uc(i,j,2)
						iii	= iii + 1
					end if
				end do
				end do
				close(1)

			end if

		end if
	end if

	if((outputSelect .eq. 0) .or. (outputSelect .eq. 2)) then
		! Uo͏
		if(mod(t, dpframe) .eq. 0) then

			! sR[h
			lf	= char(10)

			! ő̍W
			!$omp parallel do private(i,j)
			do i = 0, irange
			do j = 0, jx
				if(oj(i,j,1) + oj(i,j+1,1) .ne. 0) then
					dpm(i,j,1)	= zx(i) + (oj(i,j,1) * u(i,j,1) + oj(i,j+1,1) * u(i,j+1,1)) / (oj(i,j,1) + oj(i,j+1,1)) * ratio
				else
					dpm(i,j,1)	= 0.0d0
				end if
				if(oj(i,j,2) + oj(i+1,j,2) .ne. 0) then
					dpm(i,j,2)	= zy(j) + (oj(i,j,2) * u(i,j,2) + oj(i+1,j,2) * u(i+1,j,2)) / (oj(i,j,2) + oj(i+1,j,2)) * ratio
				else
					dpm(i,j,2)	= 0.0d0
				end if
			end do
			end do

			! ő̕ψʃt@CI[v
			write(str, '("_", i8.8)') t / dpframe
			open(1, file='output/paraview/pv_'//trim(fn)//'_u'//trim(str)//'.vtk', status='replace', access='stream', convert='big_endian')

			! wb_o
			buffer = '# vtk DataFile Version 2.0'//lf				; write(1) trim(buffer)
			buffer = 'pv_'//trim(fn)//'_u'//trim(str)//'.vtk'//lf	; write(1) trim(buffer)
			buffer = 'BINARY'//lf									; write(1) trim(buffer)
			buffer = 'DATASET UNSTRUCTURED_GRID'//lf				; write(1) trim(buffer)

			! POINTSo
			write(number1(1:8),'(i8)') spointcount 
			buffer = 'POINTS '//number1//' float'//lf				; write(1) trim(buffer)
			do i = 1, spointcount
				write(1) real(dpm(sidx(i,1),sidx(i,2),1))
				write(1) real(dpm(sidx(i,1),sidx(i,2),2))
				write(1) 0.0
			end do

			! CELLSo
			write(number1(1:8),'(i8)') scellcount
			write(number2(1:8),'(i8)') 5 * scellcount
			buffer = lf//'CELLS '//number1//' '//number2//lf		; write(1) trim(buffer)
			do i = 1, scellcount
				write(1) 4
				do j = 1, 4
					write(1) sid(i,j)
				end do
			end do

			! CELL_TYPESo
			write(number1(1:8),'(i8)') scellcount
			buffer = lf//'CELL_TYPES '//number1//lf					; write(1) trim(buffer)
			do i = 1, scellcount
				write(1) 9
			end do

			! ő̕ψʃt@CN[Y
			close(1)

			! ̉t@CI[v
			open(2, file='output/paraview/pv_'//trim(fn)//'_p'//trim(str)//'.vtk', status='replace', access='stream', convert='big_endian')

			! wb_o
			buffer = '# vtk DataFile Version 2.0'//lf				; write(2) trim(buffer)
			buffer = 'pv_'//trim(fn)//'_p'//trim(str)//'.vtk'//lf	; write(2) trim(buffer)
			buffer = 'BINARY'//lf									; write(2) trim(buffer)
			buffer = 'DATASET UNSTRUCTURED_GRID'//lf				; write(2) trim(buffer)

			! POINTSo
			write(number1(1:8),'(i8)') fpointcount 
			buffer = 'POINTS '//number1//' float'//lf				; write(2) trim(buffer)
			do i = 1, fpointcount
				write(2) real(zx(fidx(i,1)))
				write(2) real(zx(fidx(i,2)))
				write(2) 0.0
			end do

			! CELLSo
			write(number1(1:8),'(i8)') fcellcount
			write(number2(1:8),'(i8)') 5 * fcellcount
			buffer = lf//'CELLS '//number1//' '//number2//lf		; write(2) trim(buffer)
			do i = 1, fcellcount
				write(2) 4
				do j = 1, 4
					write(2) fid(i,j)
				end do
			end do

			! CELL_TYPESo
			write(number1(1:8),'(i8)') fcellcount
			buffer = lf//'CELL_TYPES '//number1//lf					; write(2) trim(buffer)
			do i = 1, fcellcount
				write(2) 9
			end do

			! CELL_DATAo
			write(number1(1:8),'(i8)') fcellcount
			buffer = 'CELL_DATA '//number1//lf						; write(2) trim(buffer)
			buffer = 'SCALARS Sound_Pressure float'//lf				; write(2) trim(buffer)
			buffer = 'LOOKUP_TABLE default'//lf						; write(2) trim(buffer)
			do i = 1, fcellcount
				write(2) real(navu(fpidx(i,1), fpidx(i,2)))
			end do

			! ̉t@CN[Y
			close(2)

		end if
	end if

	! io
	if(tx .ge. 100) then
		if(dble(t) .gt. dble(tcount) * txstep) then
			call date_and_time(date, time, zone, values)
			write(*,'(a,i3,a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Calculation ', nint(dble(tcount) * tpact), ' % completed : ', &
				values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
			write(3,'(a,i3,a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Calculation ', nint(dble(tcount) * tpact), ' % completed : ', &
				values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
			tcount	= tcount + 1
		end if
	else
		call date_and_time(date, time, zone, values)
		write(*,'(a,i3,a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Calculation ', int(dble(t) / dble(tx) * 100.0d0), ' % completed : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i3,a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Calculation ', int(dble(t) / dble(tx) * 100.0d0), ' % completed : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
	end if

end do

! io
	if(tx .ge. 100) then
		call date_and_time(date, time, zone, values)
		write(*,'(a,i3,a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Calculation ', nint(dble(tcount) * tpact), ' % completed : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
		write(3,'(a,i3,a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Calculation ', nint(dble(tcount) * tpact), ' % completed : ', &
			values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
	end if

	if((outputSelect .eq. 0) .or. (outputSelect .eq. 1)) then
		! t@CN[Y
		do i = 0, rptCount - 1
			close(11+i)
		end do
	end if

! 
	deallocate(mi, pi, pl, bc, msd, ag)
	deallocate(vx, vy, vx2, vy2, xx, xxp, xxpp)
	deallocate(txx, tyy)
	deallocate(txy)
	deallocate(ept, epv, rrp, vp, navu)
	deallocate(tin, tinsum, de)
	deallocate(mck)

	if(rptCount .ge. 1) then
		deallocate(drpts, drpti, drptj, rpts, rpti, rptj)
	end if
	if(srfCount .ge. 1) then
		deallocate(dsrfv, srfv)
	end if

	if((outputSelect .eq. 0) .or. (outputSelect .eq. 1)) then
		deallocate(uc)
	end if
	if((outputSelect .eq. 0) .or. (outputSelect .eq. 2)) then
		deallocate(oj, dpm, zx, zy)
		deallocate(sidx, sid, fidx, fid, fpidx)
	end if

! io
	call date_and_time(date, time, zone, values)
	write(*,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Process           completed : ', &
		values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)
	write(3,'(a,i4,a,i2,a,i2,a,i2,a,i2,a,i2,a,i3)') 'Process           completed : ', &
		values(1), '.', values(2), '.', values(3), ' ', values(5), ':', values(6), ':', values(7), '.', values(8)

! it@CN[Y
	close(3)

end program main